/*
 Copyright (C) 2014-2020 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"


.section .nbss, bss, near
AdcStep:		.space 2

/* OP1 Temp */
Anl0_OrgVal:		.space 2
Anl_Tmp236_0:		.space 4

/* PA Temp */
Anl1_OrgVal:		.space 2
Anl_Tmp236_1:		.space 4

/* OSC Temp */
Anl2_OrgVal:		.space 2
Anl_Tmp236_2:		.space 4

/* +24V */
Anl3_OrgVal:		.space 2
Anl_InDC:		.space 4

/* Poti */
Anl4_OrgVal:		.space 2

CpuAdcSampEnd:		.space 2

ImpCount:		.space 2
ImpTast:		.space 2
ImpMk:			.space 2
.equ bIMK_TA,			0
.equ bIMK_CLR_COUNT,		1
ImpSeg:		.space 2
ImpSegMk:	.space 2
ImpSegTi:	.space 2
.equ SEG_TI,			5	/* 1ms */
ImpTaTi:	.space 2
.equ TA_TI,			125	/* 25ms */

.global Anl0_OrgVal
.global Anl1_OrgVal
.global Anl2_OrgVal
.global Anl3_OrgVal
.global Anl4_OrgVal

.global Anl_Tmp236_0
.global Anl_Tmp236_1
.global Anl_Tmp236_2
.global Anl_InDC

.global CpuAdcSampEnd

.global ImpCount
.global ImpTast

/* ---------------------------------------------------------------------- */
.section .text
.global InitADC1
.global __AD1Interrupt

InitADC1:
; Init Default Val
	bclr	PMD1, #AD1MD

	mov	#TA_TI, w0
	mov	w0, ImpTaTi

	mov	#(1<<bIMK_TA)|(1<<bIMK_CLR_COUNT), w0
	mov	w0, ImpMk

	mov	#0x0003, w0 /* AN0 (RA0)  AN1 (RA1) */
	mov	w0, ANSELA
	mov	#0x0007, w0 /* AN2 (RB0)  AN3 (RB1)  AN4 (RB2) */
	mov	w0, ANSELB

	mov	#0x04e0, w0
	mov	w0, AD1CON1
	mov	#0x0000, w0
	mov	w0, AD1CON2

; 1/FCY * (16 + SAMC) * (ADCS + 1)
; b12..8 = SAMC   b7..0 = ADCS
;	mov	#0x0A82, w0	/* 68MHz 80.088us 4*AN -> ~5.00ks*/
	mov	#0x0A62, w0	/* 64MHz 40.218us 5*AN -> ~5.00ks*/

	mov	w0, AD1CON3

	mov	#0x0000, w0
	mov	w0, AD1CON4

	mov	#0x0000, w0
	mov	w0, AD1CHS0
	mov	#0x0000, w0
	mov	w0, AD1CHS123

	mov	#0x0000, w0
	mov	w0, AD1CSSH
	mov	#0x0000, w0
	mov	w0, AD1CSSL


	bset	AD1CON1, #ADON

/* Clear AD1 Interrupt Flag */
	bclr	IFS0, #AD1IF
/* Enable AD1 interrupt */
	bset	IEC0, #AD1IE

	bset	AD1CON1, #SAMP
	return

/*
1k:2k2		1,45	0xAEA
1k:1k		2.0	0x7FF
1k:688		2,45	0x685
*/
.equ AB_11,		0x0C00
.equ AB_10,		0x0900
.equ AB_01,		0x0740
.equ AB_00,		0x05C0

__AD1Interrupt:
	push.d	w0
	mov	ADC1BUF0, w0

	btsts	AdcStep, #0
	bra	z, ad0_Tmp236_0
	btsts	AdcStep, #1
	bra	z, ad1_Tmp236_1
	btsts	AdcStep, #2
	bra	z, ad2_Tmp236_2
	btsts	AdcStep, #3
	bra	z, ad3_24V

 TEST_PIN0_TGL
	setm	CpuAdcSampEnd

/* ---------------- ad4 Poti ------------------------ */
ad4_Poti:
;	mov	#0x0000, w1	/* next anl 0  */
;	mov	w1, AD1CHS0
	clr	AD1CHS0

	push	w2
	add	Anl4_OrgVal, WREG
	asr	w0, w0
	mov	w0, Anl4_OrgVal
.if 0
	mov	w0, w2

	cp0	ImpTaTi
	bra	nz, adPoti_Ta

	mov	#3, w0
	mov	#AB_11, w1
	cp	w2, w1
	bra	gtu, adPoti_seg

	dec	w0, w0
	mov	#AB_10, w1
	cp	w2, w1
	bra	gtu, adPoti_seg

	dec	w0, w0
	mov	#AB_01, w1
	cp	w2, w1
	bra	gtu, adPoti_seg

	dec	w0, w0
	mov	#AB_00, w1
	cp	w2, w1
	bra	gtu, adPoti_seg
	inc	ImpTaTi
	bra	adPoti_end
adPoti_Ta:
	mov	#AB_00, w1
	cp	w2, w1
	bra	gtu, adPoti_TaDec
	btst	ImpMk, #bIMK_TA
	bra	nz, adPoti_end
	inc	ImpTaTi
	mov	#TA_TI, w0
	cp	ImpTaTi
	bra	ltu, adPoti_end
	bset	ImpMk, #bIMK_TA
	setm	ImpTast
	bra	adPoti_end

adPoti_TaDec:
	dec	ImpTaTi
	btsc	SR, #Z
	bclr	ImpMk, #bIMK_TA
	mov	ImpSegMk, w0
	mov	w0, ImpSeg
	mov	#SEG_TI, w0
	mov	w0, ImpSegTi
	bra	adPoti_end

adPoti_seg:
	cp	ImpSeg
	btss	SR, #Z
	clr	ImpSegTi
	mov	w0, ImpSeg

	mov	#SEG_TI, w0
	cp	ImpSegTi
	bra	ltu, adPoti_end_inc
	bra	gtu, adPoti_end

	mov	ImpSegMk, w0
	cp	ImpSeg
	bra	z, adPoti_end

	mov	ImpSeg, w1
	mov	w1, ImpSegMk
	btst	ImpMk, #bIMK_CLR_COUNT
	bra	nz, adPoti_c_clr

	lsr	w0, w0
	xor	w0, w1, w0
	btst	w0, #0
	bra	z, adPoti_c_inc
	dec	ImpCount
	bra	adPoti_end_inc

adPoti_c_clr:
	bclr	ImpMk, #bIMK_CLR_COUNT
	clr	ImpCount
	bra	adPoti_end

adPoti_c_inc:
	inc	ImpCount
adPoti_end_inc:
	inc	ImpSegTi
adPoti_end:
.endif
	bset	AD1CON1, #SAMP
	clr	AdcStep
	pop	w2
	pop.d	w0
	bclr	IFS0, #AD1IF
	retfie

/* ---------------- ad0  ------------------------ */
ad0_Tmp236_0:
	mov	#0x0001, w1	/* next anl 1  */
	mov	w1, AD1CHS0

	push.d	w2
/*  fg = sampl / (512 * 2 * pi) */
/*  fg = sampl * 0.0003108  ~~> 1.5Hz */
	mov	#Anl0_OrgVal, w3
	mov	#0xff80, w1
	add	w0, [w3], w2
	mov	w0, [w3]
	mul.uu	w1, [++w3], w0
	add	w0, [++w3], [w3]
	addc	w1, #0, w1
	sl	w2, #10, w0
	add	w0, [w3], [w3]
	lsr	w2, #6, w2
	addc	w1, w2, [--w3]

	bset	AD1CON1, #SAMP
	pop.d	w2
	pop.d	w0
	bclr	IFS0, #AD1IF
	retfie


/* ---------------- ad1  ------------------------ */
ad1_Tmp236_1:
	mov	#0x0002, w1	/* next anl 2  */
	mov	w1, AD1CHS0

	push.d	w2
/*  fg = sampl / (512 * 2 * pi) */
/*  fg = sampl * 0.0003108  ~~> 1.5Hz */
	mov	#Anl1_OrgVal, w3
	mov	#0xff80, w1
	add	w0, [w3], w2
	mov	w0, [w3]
	mul.uu	w1, [++w3], w0
	add	w0, [++w3], [w3]
	addc	w1, #0, w1
	sl	w2, #10, w0
	add	w0, [w3], [w3]
	lsr	w2, #6, w2
	addc	w1, w2, [--w3]

	bset	AD1CON1, #SAMP
	pop.d	w2
	pop.d	w0
	bclr	IFS0, #AD1IF
	retfie

/* ---------------- ad2  ------------------------ */
ad2_Tmp236_2:
	mov	#0x0003, w1	/* next anl 3  */
	mov	w1, AD1CHS0

	push.d	w2
/*  fg = sampl / (512 * 2 * pi) */
/*  fg = sampl * 0.0003108  ~~> 1.5Hz */
	mov	#Anl2_OrgVal, w3
	mov	#0xff80, w1
	add	w0, [w3], w2
	mov	w0, [w3]
	mul.uu	w1, [++w3], w0
	add	w0, [++w3], [w3]
	addc	w1, #0, w1
	sl	w2, #10, w0
	add	w0, [w3], [w3]
	lsr	w2, #6, w2
	addc	w1, w2, [--w3]

	bset	AD1CON1, #SAMP
	pop.d	w2
	pop.d	w0
	bclr	IFS0, #AD1IF
	retfie

/* ---------------- ad3_+24V ------------------------ */
ad3_24V:
	mov	#0x0004, w1	/* next anl 4  */
	mov	w1, AD1CHS0

	push.d	w2
/*  fg = sampl / (64 * 2 * pi) */
/*  fg = sampl * 0.0003108  ~~> 12.4Hz */
	mov	#Anl3_OrgVal, w3
	mov	#0xfc00, w1
	add	w0, [w3], w2
	mov	w0, [w3]
	mul.uu	w1, [++w3], w0
	add	w0, [++w3], [w3]
	addc	w1, #0, w1
	sl	w2, #13, w0
	add	w0, [w3], [w3]
	lsr	w2, #3, w2
	addc	w1, w2, [--w3]

	bset	AD1CON1, #SAMP
	pop.d	w2
	pop.d	w0
	bclr	IFS0, #AD1IF
	retfie
