
.equ __33EP128GP506, 1   
.include "p33EP128GP506.inc"

	USE_DEBUG_UART	= 1
.if USE_DEBUG_UART
	USE_DEBUG_UART_USER	= 1
	USE_UART_LIST_PARA	= 1
.else
	USE_DEBUG_UART_USER	= 0
	USE_UART_LIST_PARA	= 0
.endif
	USE_DEBUG_UART_BRIDGE	= 0
	USE_UART_I2C_BRIDGE	= 1
	HAS_VIDEO_BUFFER	= 1


	OSC_FRQ  = 8000000
	PLL_PRE  = 0
	PLL_DIV  = 62
	PLL_POST = 2

/*	4000000 * (62+2) = 256000000  / 2 = 128000000 / 2 -> 64.0 MHz */
/*	4000000 * (66+2) = 272000000  / 2 = 136000000 / 2 -> 68.0 MHz */
	FOSC = ((OSC_FRQ / (PLL_PRE + 2)) * (PLL_DIV + 2)) / PLL_POST
	FCY  = FOSC / 2

	TIMER_FREQ	= 50000
;	TIMER_K_100US	= TIMER_FREQ / 10000

	BAUDRATE	= 115200
	MAX_RS_BUFFER	= 256
	INFO_DataArt	= 0x0003  /* max.data=256, no 4x, no RLE, no LZW */


	CPU_FACTORY	= 1
;	CPU_TYPE	= 0x1E4D
	MAX_RAM		= 0x5000	/* 33EP128GP506 */

	FM24CL048SIG	= 36		/* LE0036 */

	USE_PLL_CDCE913 = 1

	ADC_PA_MCP3421_AUTORANGE = 1

/* Test PLL */
	TEST_PLL_NPQR		= 0

	XR_DATA_SEG_SIZE	= 1


/* Display val Flags dvf
  15  14  13  12  11  10   9   8   7   6   5   4   3   2   1   0
 +---+-----------+---+-----------+--------+--+---+---+---+----+--+
 |   |    Nk     |   |   Num     |       |0.5|Fon|   |32 |Byte|US|
 +---+-----------+---+-------------------+---+---+---+---+----+--+
 */
	bDVF_IS_UNSIGN		= 0
	bDVF_IS_BYTE		= 1
	bDVF_IS_1616		= 2
	bDVF_FONT		= 4	/* 0=8x13  1=cs */
	bDVF_DISP_05		= 5

	DVF_NUM_SIFT		= 8
	DVF_NUM_MASK		= 0x0007
	DVF_NK_SIFT		= 12
	DVF_NK_MASK		= 0x0007

/*
 bDVF_IS_BYTE=1   bDVF_IS_1616=0	 8 Bit  --> i16toppc
 bDVF_IS_BYTE=0   bDVF_IS_1616=0	16 Bit  --> i16toppc
 bDVF_IS_BYTE=0   bDVF_IS_1616=1	32 Bit  --> i1616Dx6toppc
 bDVF_IS_BYTE=1   bDVF_IS_1616=1	32 Bit  --> i1616toppc  only round  
*/

/* --------------------- SPI LCD ---------------------------------------- */
.macro SENDWORD_SPI_LCD
	disi	#2
	mov	w0, SPI1BUF
	mov	SPI1BUF, w0
.endm

.macro SPI_LCD_TestTxD_End
	btst	SPI1STAT, #SPIRBF
.endm

.macro SPI_LCD_TestTxD_FULL
	btst	SPI1STAT, #SPITBF
.endm

.macro SPI_LCD_CE_OFF
	bclr LATE, #15
.endm
.macro SPI_LCD_CE_ON
	bset LATE, #15
.endm
.macro SPI_LCD_CE_BTSS
	btss LATE, #15
.endm

.macro SPI_LCD_A0_OFF
	bclr LATE, #14
.endm
.macro SPI_LCD_A0_ON
	bset LATE, #14
.endm

.macro SPI_LCD_CE_MCP23S18_OFF
	bclr LATE, #12
.endm
.macro SPI_LCD_CE_MCP23S18_ON
	bset LATE, #12
.endm


/* --------------------- I2C -------------------------------------------- */

	I2C_MAX_BUF	= 32
.if USE_UART_I2C_BRIDGE
/*  I2C_MAX_BUF   16=0x01 32=0x02 64=0x03  */
	INFO0_EX	= 0x0002
.else
	INFO0_EX	= 0x0000
.endif

.equ I2C_WRITE,		1
.equ I2C_READ,		2
.equ I2C_ERROR,		3
/* i2c2_Flag */
.equ I2C_bNoADR,	0
.equ I2C_bADR10Bit,	1

.equ I2C_NoADR,		0x01

/* i2c2_Lock == Error Bit == (i2c2_Lock+1 == SYSERR)*/

.equ I2C_Defect,	0
.equ I2C_FM24CL048,	1
.equ I2C_MCP3421,	2
.equ I2C_ADS112c04,	3
.equ I2C_DAC7578,	4
.equ I2C_MCP47FEB,	5
.equ I2C_AD5667,	6
.equ I2C_MCP4726,	7
.equ I2C_CDCE913,	8

.equ I2C2_UART,		15


/* --------------------- Key -------------------------------------------- */
.equ KEY_UP,		6
.equ KEY_DOWN,		4
.equ KEY_RIGHT,		1
.equ KEY_LEFT,		9

.equ KEY_SEL_TGL,	5
.equ KEY_OPEN,		2
.equ KEY_RET,		8

.equ KEY_Offset,	14
.equ KEY_Inv,		13
.equ KEY_Square,	12


/* Auto Cal ErrorNo */
.equ ACERR_OUT_VAL,		1
.equ ACERR_VAL_OVERRUN,		2

/* KorrFlags */
.equ bKF_GainFreqOffset,	0
.equ bKF_PA_TempOff,		1
;.equ bKF_VAC821IN_TempOff,	2

	C1_PORT			= LATC
	C1_BIT			= 6
	C2_PORT			= LATB
	C2_BIT			= 9
	C3_PORT			= LATC
	C3_BIT			= 13

	SQUARE_PORT		= LATC
	SQUARE_BIT		= 7

	INV_PORT		= LATC
	INV_BIT			= 8

	LED_GN_PORT		= LATC
	LED_GN_BIT		= 4
	LED_RT_PORT		= LATC
	LED_RT_BIT		= 5
/*
.macro LED_GN_ON
	bclr  LATC, #4
.endm
.macro LED_GN_OFF
	bset  LATC, #4
.endm

.macro LED_RT_ON
	bclr  LATC, #5
.endm
.macro LED_RT_OFF
	bset  LATC, #5
.endm
*/
	OP_OFFS_PORT		= LATF
	OP_OFFS_BIT		= 0

	OP1_ON_PORT		= LATF
	OP1_ON_BIT		= 1

	PA_POW_PORT		= LATG
	PA_POW_BIT		= 8

	HT1_PORT		= LATA
	HT1_BIT			= 11

	HT2_PORT		= LATB
	HT2_BIT			= 15

	PWM_FAN_PORT		= LATG
	PWM_FAN_BIT		= 7

	FAN1_PORT		= LATG
	FAN1_BIT		= 9
	FAN2_PORT		= LATA
	FAN2_BIT		= 12

	GV_PORT			= LATC
	GV_BIT			= 9

	CCLK_PORT		= PORTB
	CCLK_LAT		= LATB
	CCLK_BIT		= 8

	K01DB_PORT		= LATD
	K01DB_BIT		= 6
	K02DB_PORT		= LATB
	K02DB_BIT		= 12
	K04DB_PORT		= LATB
	K04DB_BIT		= 13
	K08DB_PORT		= LATA
	K08DB_BIT		= 10
	K16DB_PORT		= LATA
	K16DB_BIT		= 7
	K32DB_PORT		= LATB
	K32DB_BIT		= 14

	K60CM_PORT		= LATB
	K60CM_BIT		= 11

	KFILT_PORT		= LATB
	KFILT_BIT		= 10

	TDR_DC_PORT		= LATD
	TDR_DC_BIT		= 5

;.macro K1_ON
;	bset  LATB, #10
;.endm
;.macro K1_OFF
;	bclr  LATB, #10
;.endm

;.macro K2_ON
;	bset  LATB, #11
;.endm
;.macro K2_OFF
;	bclr  LATB, #11
;.endm

.macro TEST_PIN0_CLR
	bclr LATB, #3
.endm

.macro TEST_PIN0_SET
	bset LATB, #3
.endm

.macro TEST_PIN0_TGL
	btg LATB, #3
.endm

