/*
 Copyright (C) 2014-2022 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"

	TIMER_COUNT_500US	= TIMER_FREQ / 2000

.section .nbss, bss, near
t_Count:	.space 2
t_500us:	.space 2
t_ms:		.space 2
t_free_run:	.space 2
t_proc_mk:	.space 2

.global t_500us
.global t_ms
.global t_free_run
.global t_proc_mk

/* ---------------------------------------------------------------------- */
.section .text
.global InitTimer1
.global __T1Interrupt
.global InitFreqCounter

InitTimer1:
	mov	#TIMER_COUNT_500US, w0
	mov	w0, t_Count
	clr	t_500us
	clr	t_ms
	clr	TMR1
	mov	#((FCY - (TIMER_FREQ / 2)) / TIMER_FREQ), w0
	mov	w0, PR1
	clr	T1CON
	bset	IPC0, #T1IP1 /* Set Timer1 interrupt priority to 6 */
	bclr	IFS0, #T1IF
	bset	IEC0, #T1IE
	bset	T1CON, #TON
	return

__T1Interrupt:
	inc	t_free_run
	clr	t_proc_mk

	dec	t_Count
	bra	z, T1_ms1
	bclr	IFS0, #T1IF
	retfie

T1_ms1:
	push.d	w0

	mov	#TIMER_COUNT_500US, w0
	mov	w0, t_Count
	inc	t_500us
	btss	t_500us, #0
	inc	t_ms
T1_ms1_e:
	pop.d	w0
	bclr	IFS0, #T1IF
	retfie
