/*
 Copyright (C) 2014-2016 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"

	BRGVAL = (((FCY/BAUDRATE) + 7) / 16) - 1 

.section .nbss, bss, near
RxD_dbgbuf:	.space MAX_RS_BUFFER
TxD_dbgbuf:	.space MAX_RS_BUFFER

.global TxD_dbgbuf
.global RxD_dbgbuf

.section .text
.global InitUART_dbg
.global __DMA0Interrupt
.global Start_UART_dbg_TxD
.global ReStart_UART_dbg_TxD
.global GetByte_UART_dbg_RxD

InitUART_dbg:
	bclr	PMD1, #U2MD
	bclr	PMD7, #DMA0MD

	bclr	IEC4, #U2EIE

	mov	#0x0000, w0
	mov	w0, U2MODE

	mov	#BRGVAL, w0
	mov	w0, U2BRG

	bset	U2MODE, #UARTEN

	bset	U2STA, #UTXEN

/* Associate DMA Channel 0 with UART Tx */
	mov	#0x001F, w0
	mov	w0, DMA0REQ
	mov	#U2TXREG, w0
	mov	w0, DMA0PAD
/* One-Shot, Post-Increment, RAM-to-Peripheral */
	mov	#0x6001, w0
	mov	w0, DMA0CON

	mov	#TxD_dbgbuf, w0
	mov	w0, DMA0STAL
	mov	#0x0000, w0
	mov	w0, DMA0STAH

/* Clear DMA Interrupt Flag */
	bclr	IFS0, #DMA0IF
/* Enable DMA interrupt */
;	bset	IEC0, #DMA0IE
	return

__DMA0Interrupt:
; TEST_PIN0_TGL
	bclr	IFS0, #DMA0IF
	retfie

/* w0 = data len */
Start_UART_dbg_TxD:
	mov	w0, DMA0CNT
ReStart_UART_dbg_TxD:
	setm	U2TXREG
/* Re-enable DMA0 Channel */
	bset	DMA0CON, #CHEN
/* Manual mode: Kick-start the first transfer */
	bset	DMA0REQ, #FORCE
	return

/* w0 = 0=false 1=true   w1=byte */
GetByte_UART_dbg_RxD:
.if USE_DEBUG_UART_BRIDGE
	mov	BridgeMod, w0
	mov	#BRIDGE_RUN, w1
	cp	w0, w1
	bra	nz, 12f
	call	UART_dbg_bridge_RxD
12:
.endif
/* Test rd Error */
	mov	U2STA, w1
	and	w1, #((1 << OERR)|(1 << FERR)|(1 << PERR)), w0
	bra	nz, UART2_ExERR
 
	btss	w1, #URXDA
	retlw	#0, w0
; TEST_PIN0_TGL
.if USE_DEBUG_UART_BRIDGE
	mov	BridgeMod, w0
	mov	#BRIDGE_RUN, w1
	cp	w0, w1
	bra	nz, 22f
	mov	U2RXREG, w1
	mov	w1, U1TXREG
	retlw	#1, w0
22:
.endif
	mov	U2RXREG, w1
	retlw	#1, w0

UART2_ExERR:
; TEST_PIN0_TGL
	call	InitUART_dbg
	retlw	#0, w0
