/*
 Copyright (C) 2014-2023 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "main.inc"
.include "lib/eingVx.inc"
.include "lib/Analog.inc"
.include "lib/Param.inc"
.include "math/libm.inc"

	fOP1_ADC_SUM		= AcF48_0

	pgm_Step		= AcTmpMem
	pgm_Flag		= AcTmpMem+2
	MAXCOUNT		= AcTmpMem+4
	pGen_Test_V		= AcTmpMem+6

	CAL_LOOP		= 1
	CAL_SYM			= 1

.if CAL_SYM
	bPGMF_SYM		= 0
.endif

;.section .nbss, bss, near

/* ______________________________________________________________________ */
.section .text
.global InitAutoCalGenV
.global AutoCalGenV
.global LCD_AutoCalGenV
.global K_Ret_AutoCalGenV

InitAutoCalGenV:
	bset	AutoCalDAC, #bAC_ADS112_OP1V
;	bset	TestFlags, #bTF_DAC

	mov	#0x003E, w0
	rcall	SetAmplRelais

	mov	#16000, w0
	mov	#0, w1
	clr	w2
	mov	w0, GenFreq
	mov	w1, GenFreq+2
	mov	w2, GenFreq+4
	rcall	MathFreq

;	clr	pgm_Step
;	clr	pgm_Flag

	mov	#F48_0, w0
	repeat	#F48_GLOB_MEM_CLR_COUNT
	clr	[w0++]

	mov	#4, w0
	mov	w0, ac_start_count
	return

/* ---------------------------------------------------------------------- */
LCD_AutoCalGenV:
	dec	w0, w0
	mov	w0, w1
	bra	z, LineV
	dec	w0, w0
	bra	z, LineV
	dec	w0, w0
	bra	z, LineV
	dec	w0, w0
	bra	z, LineV
	dec	w0, w0
	bra	z, Line6
	dec	w0, w0
	bra	z, LineGr
	bra	LCD_Paint

LineV:
	mul.uu	w1, #9, w2
	add	#20, w2
	push	w2			; Line Y

	push.d	w8
	mul.uu	w1, #F48_SIZE, w2
	mov	#AcDispVals, w8
	add	w8, w2, w8
	add	w8, w2, w8		; Line fval 1 + 2

	mov	#F48_0, w9
	add	w9, w2, w9		; Line fval 3

	mov	w8, w2
	mov	#FC48_10, w3
	mov	#F48_tmp_0, w4
	rcall	f48_mul
	rcall	f48_i1616

	mov	#Str_buffer, w3
	mov	#2, w2
	mov	#5, w4
	rcall	i1616Dx6toppc
	mov	#0x81, w0
	mov.b	w0, [w3++]

	push	w3
	add	w8, #F48_SIZE, w2
	mov	#FC48_10, w3
	mov	#F48_tmp_0, w4
	rcall	f48_mul
	rcall	f48_i1616
	pop	w3

	mov	#2, w2
	mov	#5, w4
	rcall	i1616Dx6toppc
	mov	#0x81, w0
	mov.b	w0, [w3++]

	push	w3
	mov	w9, w2
	mov	#FC48_100, w3
	mov	#F48_tmp_0, w4
	rcall	f48_mul
	rcall	f48_i16r
	pop	w3

	pop.d	w8

	mov	#2, w2
	rcall	int16toppc

	mov	#0x81, w0
	mov.b	w0, [w3++]
	mov	#'m', w0
	mov.b	w0, [w3++]
	mov	#'V', w0
	mov.b	w0, [w3++]
	clr.b	[w3]
	mov	#0, w0
	pop	w1
	bra	LCD_StrBufOut_cs

Line6:
	mov	#0, w0
	mov	#58, w1
	bra	StrbTemp_cs_step

LineGr:
	btst	ac_flag, #bACF_OK
	bra	nz, LCD_Step_Inc

	mov	pgm_Step, w0
	cp0	w0
	bra	z, LCD_Step_Inc
	dec	w0, w0
.if CAL_SYM
	btss	pgm_Flag, #bPGMF_SYM
.endif
	lsr	w0, w0
	and	#0x03, w0
	mul.uu	w0, #9, w0
	mov	#26, w1			; Y
	add	w1, w0, w1

	mov	#0, w0			; X
.if CAL_SYM
	btst	pgm_Flag, #bPGMF_SYM
	bra	nz, az_sym
.endif
	mov	#38, w2			; Lg
	btss	pgm_Step, #0
	mov	#40, w0			; X
.if CAL_SYM
	bra	az_line
az_sym:
	mov	#78, w2			; Lg
az_line:
.endif
	rcall	PolLineH
	inc	LCD_Step
	return

/* ---------------------------------------------------------------------- */
K_Ret_AutoCalGenV:
	btst	ac_save_mod, #bACS_SAVE_DATA
	bra	z, Key_AutoCalClose

	mov	#oFR_GENV_HP, w2
	mov	#15, w3
	rcall	FRam_Save
	bra	Key_AutoCalClose

/* ---------------------------------------------------------------------- */
calc_mem_val:
	push	w3
	mov	w8, w2
	rcall	f48_sub
	mov	#FC48_100, w2
	mov	w14, w3
	rcall	f48_mul
	rcall	f48_i16r
	mov	w0, [w9++]
	add	w8, #F48_SIZE, w8
	pop	w3

	mov	w8, w2
	rcall	f48_add
	mov	#FC48_100, w2
	mov	w14, w3
	rcall	f48_mul
	rcall	f48_i16r
	mov	w0, [w9++]
	add	w8, #F48_SIZE, w8
	return

ValToMemParamGain:
	push.d	w8
	mov	#AcDispVals, w8
	mov	#EEData0+oFR_GENV_HP, w9

	lnk	#F48_SIZE
	mov	w14, w4

	mov	#FC48_GENV_MAX_BASE, w3
	rcall	calc_mem_val

	mov	#FC48_GENV_MIN_BASE, w3
	rcall	calc_mem_val

	mov	#FC48_GENV_MIN_BASE, w3
	rcall	calc_mem_val

	mov	#FC48_GENV_MIN_BASE_1DB, w3
	rcall	calc_mem_val

	ulnk
	pop.d	w8

	bra	SetParamGain

/* w0=ac_step */
AutoCalGenV:
	inc	ac_step
	mov	#fAdcOP1_mV, w2
	mov	#fOP1_ADC_SUM, w3
	mov	#fOP1_ADC_SUM, w4

	and	#0x03, w0
	bra	nz, add_sum
	rcall	f48_mov
	return
add_sum:
	rcall	f48_add
	mov	ac_step, w0
	and	#0x03, w0
	bra	z, next_acgv
	return

next_acgv:
	mov	#-2, w0
	mov	w4, w2
	rcall	f48_shift	; val / 4.0

	mov	pgm_Step, w0

	cp0	w0
	bra	nz, acgv_m1

;.if USE_PLL_CDCE913
	rcall	pll_off
	rcall	SetGenPllSym
;.endif
	rcall	OC1_PinDisabel
	bset	GenLongTimeFlag, #bGLT_ON

	bset	GV_PORT, #GV_BIT
	bset	SQUARE_PORT, #SQUARE_BIT

	clr	w0
	bra	acgv_set_v
acgv_m1:
.if CAL_SYM
.if CAL_LOOP
	cp	w0, #25
.else
	cp	w0, #17
.endif
	bra	geu, acgv_read_sq
.endif
	cp	w0, #9
	bra	geu, acgv_read_v
/* Read Start GenV */
	mov	Temp_GEN_0025, w0
	mov	#1200, w1	/* -30 0C (0.025C * 1200) */
	sub	w0, w1, w0
	mov	#F48_tmp_0, w3
	rcall	i16_f48_w3

	mov	#FC48_0025, w2
	mov	w3, w4
	rcall	f48_mul

	mov	pgm_Step, w0
	dec	w0, w0
	and	#0x07, w0
	mov	#EEData0+oFR_TC_GENV_HP, w1	; byte
	add	w1, w0, w1

	mov	#F48_tmp_1, w3
	se	[w1], w0		/* 0.01mV/C */
	rcall	i16_f48_w3

	mov	#FC48_001, w2
	mov	w3, w4
	rcall	f48_mul

	mov	#F48_tmp_0, w2
	mov	w2, w4
	rcall	f48_mul

	btsc	fOP1_ADC_SUM+4, #15
	rcall	f48_neg

	mov	#fOP1_ADC_SUM, w2
	mov	w4, w3

	mov	pgm_Step, w0
	dec	w0, w0
	and	#0x07, w0
	mul.uu	w0, #F48_SIZE, w0
	mov	#AcDispVals, w4
	add	w4, w0, w4
	rcall	f48_add

	btst	pgm_Step, #0
	bra	nz, no_gv

	mov	pgm_Step, w0
	dec	w0, w0
	and	#0x06, w0
	mul.uu	w0, #F48_SIZE, w2
	mov	#AcDispVals, w1		; vhp_op1v
	add	w2, w1, w2		; F48 op1
	add	w2, #F48_SIZE, w3	; F48 op2
	lsr	w0, w0
	mul.uu	w0, #F48_SIZE, w0
	mov	#F48_4, w4
	add	w4, w0, w4		; F48 res  Gen Test V
	rcall	f48_sub
	mov	#-1, w0
	mov	w4, w2
	rcall	f48_shift
no_gv:
	mov	pgm_Step, w0
	cp	w0, #8
	bra	geu, acgv_m1_end
; bra	geu, AutoCalScanEnd

acgv_set_v:
	btss	w0, #0
	bclr	INV_PORT, #INV_BIT
	btsc	w0, #0
	bset	INV_PORT, #INV_BIT

	mov	#GENV_DAC_MAX, w1
	btsc	w0, #1
	mov	#GENV_DAC_MIN, w1
	mov	w1, DacGvp
	mov	w1, DacGvn

	mov	#0x003E, w1
	btsc	w0, #2
	mov	#0x003F, w1
	mov	w1, GainRelais

	mov	w1, w0
	rcall	SetAmplRelais
	rcall	SetAmplToDac
	bra	acgv_next

acgv_m1_end:
	rcall	ValToMemParamGain
	bra	acgv_set_gv

acgv_read_v:
	mov	#fOP1_ADC_SUM, w2
	mov	pGen_Test_V, w3
	sub	w3, #F48_SIZE*4, w4

	btss	pgm_Step, #0
	rcall	f48_add
	btsc	pgm_Step, #0
	rcall	f48_sub

	mov	w4, w2
	mov	#AcF48_1, w4
	rcall	f48_abs_mov

	mov	#AcF48_1, w2
	mov	#FC48_ADS112c04_OP1_DIGIT_MV, w3
	rcall	f48_cp
	bra	lt, acgv_ok
	dec	MAXCOUNT
	bra	z, acgv_ok

	mov	pgm_Step, w0
	dec	w0, w0
	and	#0x07, w0
	mul.uu	w0, #F48_SIZE, w0
	mov	#AcDispVals, w2
	add	w2, w0, w2
	mov	pGen_Test_V, w3
	sub	w3, #F48_SIZE*4, w3

	mov	w2, w4
	rcall	f48_add
	rcall	ValToMemParamGain
	rcall	SetGenV_Reload
	mov	#3, w0
	mov	w0, ac_start_count
	clr	ac_flag
	return

; bra	AutoCalScanEnd

acgv_ok:
	btst	pgm_Step, #0
	bra	z, acgv_set_gv

	bset	INV_PORT, #INV_BIT
	bra	acgv_next_set_maxcount

acgv_set_gv:
	mov	pgm_Step, w0
.if CAL_LOOP
	cp	w0, #24
.else
	cp	w0, #16
.endif
.if CAL_SYM
	bra	geu, acgv_set_sq_start
.else
	bra	geu, AutoCalScanEnd
.endif
	bclr	INV_PORT, #INV_BIT

	mov	#0x003E, w0
	btsc	pgm_Step, #2
	mov	#0x003F, w0
	mov	w0, GainRelais
	rcall	SetAmplRelais

	mov	pgm_Step, w0
	and	#0x06, w0
	lsr	w0, w0
	mul.uu	w0, #F48_SIZE, w0
	mov	#F48_4, w2
	add	w2, w0, w2		; Gen Test V
	mov	w2, pGen_Test_V
	rcall	SetGenV_w2
; bra	AutoCalScanEnd

acgv_next_set_maxcount:
	mov	#3, w0
	mov	w0, MAXCOUNT
	bra	acgv_next

.if CAL_SYM
acgv_set_sq_start:
	mov	#F48_0, w0
	repeat	#11
	clr	[w0++]

	bset	pgm_Flag, #bPGMF_SYM
	rcall	MathFreq
	bra	acgv_set_sq

acgv_read_sq:
	mov	#fOP1_ADC_SUM, w2
	mov	pGen_Test_V, w4
	sub	w4, #F48_SIZE*4, w4
	rcall	f48_mov

	mov	#fOP1_ADC_SUM, w2
	mov	#F48_tmp_0, w4
	rcall	f48_abs_mov

	mov	#F48_tmp_0, w2
	mov	#FC48_ADS112c04_OP1_DIGIT_MV, w3
	rcall	f48_cp
	bra	lt, acgv_set_sq
	dec	MAXCOUNT
	bra	z, acgv_set_sq

	mov	#-1, w0
	mov	#fOP1_ADC_SUM, w2
	mov	#F48_tmp_0, w4
	rcall	f48_shift		; offset / 2.0

	mov	pgm_Step, w0
	dec	w0, w0
	and	#0x03, w0
	mul.uu	w0, #F48_SIZE*2, w0
	mov	#AcDispVals, w2
	add	w2, w0, w2
	mov	#F48_tmp_0, w3		; add offset
	mov	w2, w4
	rcall	f48_add
	add	w2, #F48_SIZE, w2
	mov	w2, w4
	rcall	f48_add

	rcall	ValToMemParamGain
	rcall	SetGenV_Reload
	mov	#3, w0
	mov	w0, ac_start_count
	clr	ac_flag
	return

; bra	AutoCalScanEnd

acgv_set_sq:
	mov	pgm_Step, w0
.if CAL_LOOP
	cp	w0, #28
.else
	cp	w0, #20
.endif
	bra	geu, AutoCalScanEnd

	mov	#0x003E, w0
	btsc	pgm_Step, #1
	mov	#0x003F, w0
	mov	w0, GainRelais
	rcall	SetAmplRelais

	mov	pgm_Step, w0
	and	#0x03, w0
	mul.uu	w0, #F48_SIZE, w0
	mov	#F48_4, w2
	add	w2, w0, w2		; Gen Test V
	mov	w2, pGen_Test_V
	rcall	SetGenV_w2
	mov	#4, w0
	mov	w0, MAXCOUNT
	bra	acgv_next
.endif

acgv_next:
	mov	#6, w0
	mov	w0, ac_start_count
	clr	ac_flag
	inc	pgm_Step
	return

