/*
 Copyright (C) 2014-2022 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "lib/Analog.inc"

/* ---------------------------------------------------------------------- */
.section .text

.global GetCapValue

/* -------------------- f48_abs_mov ------------------------
Input:  w0=Value 0..255 (0=min.Cap 255=max.Cap) 
        w1=Diode idx
Output: w0=DacValue 0..65535
used; w0:w1:w3:w4:w5				xx Clk
------------------------------------------------------------ */
GetCapValue:
	mov	#tab_Cdio, w3
	and	w1, #0x03, w1
	sl	w1, w1

	btsc	w0, #15
	clr	w0		; is neg clr
	mov	#255, w4
	sub	w4, w0, w0
	btsc	w0, #15
	mov	w4, w0		; is ov set max

	mov	[w3+w1], w5

	ze	w0, w4
	and	#0x0F, w4
	lsr	w0, #3, w0
	and	#0x1E, w0
	add	w5, w0, w5
	clr	w3
	mov	[w5--], w1
	cp0	w0
	btss	SR, #Z
	mov	[w5], w3

	sub	w1, w3, w0
	mul.uu	w0, w4, w0
	sl	w1, #12, w1
	lsr	w0, #4, w0
	ior	w0, w1, w0
	add	w0, w3, w0
	return

/* ---------------------------------------------------------------------- */
.section .const, psv

tab_BB174:
	.word	350,	712,	1120,	1576,	2137,	2784,	3533,	4388
	.word	5499,	6981,	8776,	11397,	15102,	21028,	31913, 65535

tab_BB181:
	.word	256,	530,	861,	1231,	1675,	2159,	2787,	3562
	.word	4416,	5699,	7351,	9602,	13050,	18806,	30488, 65535

tab_BB857:
	.word	256,	504,	761,	1077,	1510,	1958,	2496,	3134
	.word	3989,	5043,	6525,	9830,	11711,	17011,	28294, 65535


tab_Cdio:
	.word	tab_BB174, tab_BB174, tab_BB181, tab_BB857

