/*
 Copyright (C) 2014-2023 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "main.inc"
.include "lib/LCD_128x64.inc"

.section .nbss, bss, near
LCD_Count:		.space 2
tLCD_mk:		.space 2
LCD_Step:		.space 2
LCD_PProc:		.space 2
LCD_ForceMk:		.space 2

.global LCD_Count
.global tLCD_mk
.global LCD_Step
.global LCD_PProc

.section .text
.global LCD_Proc
.global LCD_StrBufOut8x13
.global LCD_ConstStrOut8x13
.global LCD_Step_Inc
.global LCD_StrBufOut_cs
.global LCD_ConstStrBufOut_cs
.global LCD_Paint
.global LCD_RePaint
.global Key_proc
.global Key_RetOk_Menu
.global Key_RetRePaint
.global Key_RetOk
.global Key_RetNoHandle

.global StrbTemp
.global StrbTemp_cs
.global StrbTemp_cs_step
;.global StrTemp3
.global DispValId
.global GetK_dbX

LCD_Proc:
	cp0	LCD_Step
	bra	z, LCD_Handle	/* lib/LCD_dogm128x64.S */

	mov	LCD_Step, w0
	dec	w0, w0
	bra	z, sLCD_clr

	cp0	LCD_ForceMk
	bra	nz, AzProc

	dec	w0, w0
	bra	z, TeMath

AzProc:
	mov	LCD_PProc, w1
	and	w1, #0x0f, w1
	add	w1, w1, w1
	mov	#TAZ_proc, w2
	mov	[w1+w2], w2
	goto	w2

sLCD_clr:
	btsc	LCD_Status, #bLCD_RUN	/* Wait LCD_RUN end */
	return
	call	LCD_CLR
	inc	LCD_Step
	return
/* ______________________________________________________________________ */
TeMath:
/* ----------------------------------------------------------
VCC +24V
15k:1k2 = 13,5:1
ADC -> 1 digit = 3.5V / 4096 = 0.0008545V -> * 13.5 = 0.01153575V
K = 0.01153575 * 65536 / 0.1 = 7560.06912
----------------------------------------------------------- */
;	mov	Anl1_OrgVal, w0
;	mov	#7560, w1
;	mul.uu	w0, w1, w0
;	mov	w1, VCC_24V

.if 0
	mov	AdcPa_1616, w0
	mov	AdcPa, w1
	btst	K60CM_PORT, #K60CM_BIT
	bra	nz, lPa_ov_nc
	btst	Impedanz_Flag, #bIMP_HIGHZ_ON
	bra	nz, lPa_ov_nc

	mov	PaAdc60cmMul, w2
	mov	PaAdc60cmMul+2, w3
	rcall	mul32su
	mov	w1, w0
	mov	w2, w1
lPa_ov_nc:
	mov	w0, PaOut_mV_k
	mov	w1, PaOut_mV_k+2
.endif


	inc	LCD_Step
	return


/* ______________________________________________________________________ */
LCD_StrBufOut8x13:
	mov	#Str_buffer, w2
LCD_ConstStrOut8x13:
	rcall	StrOut8x13
LCD_Step_Inc:
	inc	LCD_Step
	return

LCD_StrBufOut_cs:
	mov	#Str_buffer, w2
LCD_ConstStrBufOut_cs:
	rcall	StrOut_cs
	inc	LCD_Step
	return

/* ______________________________________________________________________ */
LCD_Paint:
	rcall	LCD_Refresh
	clr	LCD_ForceMk
	clr	LCD_Step
	return

/* ______________________________________________________________________ */
LCD_RePaint:
	btsc	LCD_Status, #bLCD_RUN
	return
	mov	tLCD_mk, w0
	cp	w0, #25
	bra	lt, rp_end
	mov	#1, w0
	mov	w0, LCD_Step
	mov	w0, LCD_ForceMk
rp_end:
	return

/* ______________________________________________________________________ */
Key_proc:
	mov	LCD_PProc, w1
	and	w1, #0x0f, w1
	add	w1, w1, w1
	mov	#TKey_proc, w2
	nop		; stall
	mov	[w1+w2], w2
	goto	w2

Key_RetOk_Menu:
	mov	#MENU_IDX_Menu, w0
	mov	w0, LCD_PProc
;	bra	Key_RetRePaint

Key_RetRePaint:
	rcall	LCD_RePaint
Key_RetOk:
	clr	w0
Key_RetNoHandle:
	cp0	w0
	return

/* ______________________________________________________________________ */
StrbTemp:
	mov	#Str_buffer, w3
;StrTemp3:
	mov	Temp_OSC, w0
	mov	#1, w2
	rcall	uint16D3toppc

	mov	#'/', w0
	mov.b	w0, [w3++]

	mov	Temp_GEN_0025, w0
	asr	w0, w0
	asr	w0, w0
	addc	w0, #0, w0
	mov	#1, w2
	rcall	uint16D3toppc

	mov	#'/', w0
	mov.b	w0, [w3++]

	mov	Temp_OP1, w0
	mov	#1, w2
	rcall	uint16D3toppc

	mov	#'/', w0
	mov.b	w0, [w3++]

	mov	Temp_PA, w0
	mov	#1, w2
	rcall	uint16D3toppc
	mov	#txt_TC, w0	/* C */
	rcall	ppc_move
	return

/* w0=x w1=y */
StrbTemp_cs:
	push.d	w0
	rcall	StrbTemp
	pop.d	w0
	mov	#Str_buffer, w2
	bra	StrOut_cs

/* w0=x w1=y */
StrbTemp_cs_step:
	push.d	w0
	rcall	StrbTemp
	pop.d	w0
	bra	LCD_StrBufOut_cs

/* ______________________________________________________________________ */
DispValId:
	and	#0x0f, w0
	btsc	SR, #Z
	return
	mov	#Str_buffer, w3

	cp	w0, #LCDD_PA
	bra	z, did_pa
	cp	w0, #LCDD_GOV
	bra	z, did_gov
	cp	w0, #LCDD_GRV
	bra	z, did_grv
	cp	w0, #LCDD_OP1V
	bra	z, did_op1v
	cp	w0, #LCDD_24V
	bra	z, did_24v

	cp	w0, #LCDD_HEX16_V1
	bra	z, did_hex16v1
	cp	w0, #LCDD_HEX16_V2
	bra	z, did_hex16v2

	bset	SR, #Z
	return
did_pa:
	mov	#'P', w0
	mov.b	w0, [w3++]
	mov	#'A', w0
	mov.b	w0, [w3++]

	mov	AdcPa_1616, w0
	mov	AdcPa, w1

;	mov	PaOut_mV_k, w0
;	mov	PaOut_mV_k+2, w1

	mov	#1, w2
	mov	#5, w4
	rcall	i1616Dx6toppc
	bra	did_mv

did_gov:
	mov	#'G', w0
	mov.b	w0, [w3++]
	mov	#'O', w0
	mov.b	w0, [w3++]
	mov	#'V', w0
	mov.b	w0, [w3++]
	mov	GOV_01mV, w0
	bra	did_imv

did_grv:
	mov	#'G', w0
	mov.b	w0, [w3++]
	mov	#'R', w0
	mov.b	w0, [w3++]
	mov	#'V', w0
	mov.b	w0, [w3++]
	mov	GRV_01mV, w0
	bra	did_imv

did_op1v:
	mov	#'O', w0
	mov.b	w0, [w3++]
	mov	#'P', w0
	mov.b	w0, [w3++]
	mov	#'1', w0
	mov.b	w0, [w3++]
	mov	OP1V_1616_001mV, w0
	mov	OP1V_1616_001mV+2, w1
	mov	#2, w2
	mov	#5, w4
	rcall	i1616Dx6toppc
	bra	did_mv

did_imv:
	mov	#1, w2
	rcall	int16toppc
did_mv:

	mov	#'m', w0
	mov.b	w0, [w3++]
	mov	#'V', w0
	mov.b	w0, [w3++]
	clr.b	[w3]
	bclr	SR, #Z
	return

did_24v:
	mov	#'2', w0
	mov.b	w0, [w3++]
	mov	#'4', w0
	mov.b	w0, [w3++]
	mov	#'V', w0
	mov.b	w0, [w3++]
	mov	VCC_01V, w0

	mov	#1, w2
	rcall	int16toppc
	mov	#'V', w0
	mov.b	w0, [w3++]
	clr.b	[w3]
	bclr	SR, #Z
	return

did_hex16v1:
	mov	#'0', w0
	mov.b	w0, [w3++]
	mov	#'x', w0
	mov.b	w0, [w3++]
	mov	LcdTeVal1, w0
	mov	#4, w2
	rcall	hex16toppc
	return

did_hex16v2:
	mov	#'0', w0
	mov.b	w0, [w3++]
	mov	#'x', w0
	mov.b	w0, [w3++]
	mov	LcdTeVal2, w0
	mov	#4, w2
	rcall	hex16toppc
	return

/* ______________________________________________________________________ */
GetK_dbX:
	clr	w0
	btsc	K01DB_PORT, #K01DB_BIT
	bset	w0, #0
	btsc	K02DB_PORT, #K02DB_BIT
	bset	w0, #1
	btsc	K04DB_PORT, #K04DB_BIT
	bset	w0, #2
	btsc	K08DB_PORT, #K08DB_BIT
	bset	w0, #3
	btsc	K16DB_PORT, #K16DB_BIT
	bset	w0, #4
	btsc	K32DB_PORT, #K32DB_BIT
	bset	w0, #5
	return

/* ______________________________________________________________________ */
.section .const, psv
TAZ_proc:
	.dc	LCD_main,	LCD_Menu,	LCD_Info,	LCD_EingPara
	.dc	LCD_Flags,	LCD_TestDac,	LCD_Filter,	LCD_FiltKx
	.dc	LCD_AutoCal,	LCD_Impedanz,	LCD_Sym,	LCD_main
	.dc	LCD_main,	LCD_main,	LCD_main,	LCD_main

TKey_proc:
	.dc	Key_main,	Key_Menu,	Key_Info,	Key_EingPara
	.dc	Key_Flags,	Key_TestDac,	Key_Filter,	Key_FiltKx
	.dc	Key_AutoCal,	Key_Impedanz,	Key_Sym,	Key_main
	.dc	Key_main,	Key_main,	Key_main,	Key_main
