/*
 Copyright (C) 2014-2023 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "lib/Param.inc"

.section .text
.global LCD_Info
.global Key_Info

.if USE_UART_LIST_PARA
.global get_val_Info
.endif

LCD_Info:
	dec	w0, w0
	bra	nz, TeLine1

	mov	#0, w0
	mov	#0, w1
	mov	#txtInfo1, w2
	bra	LCD_ConstStrOut8x13

TeLine1:
	dec	w0, w0
	bra	nz, TeLine2

	mov	#0, w0
	mov	#16, w1
	mov	#txtInfo2, w2
	bra	LCD_ConstStrOut8x13

TeLine2:
	dec	w0, w0
	bra	nz, TeLine3

	mov	#0, w0
	mov	#32, w1
	mov	#txtInfo3, w2
	bra	LCD_ConstStrOut8x13

TeLine3:
	dec	w0, w0
	bra	nz, TeLine4

	btst	LCD_Count, #2
	bra	nz, LCD_Step_Inc
	cp0	SysError
	bra	z, LCD_Step_Inc

	mov	#Str_buffer, w3
	rcall	PrintSysError

	mov	#0, w0
	mov	#48, w1
	bra	LCD_StrBufOut8x13

TeLine4:
	dec	w0, w0
	bra	nz, LCD_Paint

	mov	#Str_buffer, w3
	mov	#txtInfo4, w0
	rcall	ppc_move
	
	mov	EEData0+oFR_RUN_TIME, w0
	mov	EEData0+oFR_RUN_TIME+2, w1
	mov	#60, w2
	repeat	#17
	div.ud	w0, w2
	mov	#0, w2
	rcall	uint16toppc

	mov	#0, w0
	mov	#58, w1
	bra	LCD_StrBufOut_cs

/* ______________________________________________________________________ */
Key_Info:
	cp	w0, #KEY_UP
	bra	z, Key_RetOk
	cp	w0, #KEY_DOWN
	bra	z, Key_RetOk
	cp	w0, #KEY_OPEN
	bra	z, Key_RetOk
	cp	w0, #KEY_RET
	bra	z, Key_RetOk_Menu
	return

/* ______________________________________________________________________ */
.if USE_UART_LIST_PARA
/* w2=LineIdx w7=ParamLine w4=Ext Data */
get_val_Info:

	mov	#Str_buffer, w3
	mov	#txtInfo1, w0
	cp	w2, #1
	bra	z, ppc_move
	mov	#txtInfo2, w0
	cp	w2, #2
	bra	z, ppc_move
	mov	#txtInfo3, w0
	cp	w2, #3
	bra	z, ppc_move
	bra	ucMenuSend_NULL

.endif  /* USE_UART_LIST_PARA */

/* ______________________________________________________________________ */
.section .const, psv

.global txtInfo1
.global txtInfo2

txtInfo1:	.asciz	"PG9 LE0036"
txtInfo2:	.asciz	"Ver. 1.0.0"
txtInfo3:	.asciz	"ALDccp (C)2023"
txtInfo4:	.asciz	"Runtime "
