/*
 Copyright (C) 2014-2023 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "main.inc"
.include "lib/eingVx.inc"
.include "lib/Analog.inc"

	EingDac1 = EingVx0
	EingDac2 = EingVx1
	EingDac3 = EingVx2
	EingDac4 = EingVx3

.section .nbss, bss, near
EingClx:		.space 4
akt_line:		.space 2
akt_max_line:		.space 2

;EingDac1:		.space EVX_SIZE
;EingDac2:		.space EVX_SIZE
;EingDac3:		.space EVX_SIZE
;EingDac4:		.space EVX_SIZE

/* ______________________________________________________________________ */
.section .text

.global init_TestDac
.global LCD_TestDac
.global Key_TestDac
.global GetDAC_txt

/* ______________________________________________________________________ */
init_TestDac:
	mov	#EingClx, w6
	rcall	EingVx_Push_CursLineIdx

	mov	[w4], w8
	and	w8, #3, w0		/* max.line-1 */
	mov	w0, akt_max_line
	mov	akt_line, w1		/* akt.line */
	rcall	EingVx_InitCursLineIdx

/* EingDac1 */
	mov	#EingDac1, w5
	mov	#0, w0
	rcall	init_line

	cp0	akt_max_line		/* max.line-1 == 0 */
	bra	z, liend

/* EingDac2 */
	mov	#EingDac2, w5
	mov	#1, w0
	rcall	init_line

	mov	akt_max_line, w0	/* max.line-1 == 1 */
	cp	w0, #1
	bra	z, liend

/* EingDac3 */
	mov	#EingDac3, w5
	mov	#2, w0
	rcall	init_line

	mov	akt_max_line, w0	/* max.line-1 == 2 */
	cp	w0, #2
	bra	z, liend

/* EingDac4 */
	mov	#EingDac4, w5
	mov	#3, w0
	rcall	init_line

liend:
	return


/* ______________________________________________________________________ */
LCD_TestDac:
	dec	w0, w0
	bra	z, LCD_MenuCaption
	dec	w0, w0
	bra	z, ParaStatus
	mov	akt_max_line, w1
	dec	w0, w0
	bra	z, Line1
	dec	w0, w0
	bra	z, Line2
	dec	w0, w0
	bra	z, Line3
	dec	w0, w0
	bra	z, Line4
	bra	LCD_Paint
ParaStatus:
	rcall	StatusLine
	mov	#0, w0
	mov	#14, w1
	bra	LCD_StrBufOut_cs

Line1:

	mov	#EingDac1, w5

	mov	#1, w0
	rcall	md_get_dac_txt

	rcall	DispVxVal

	mov	#Str_buffer, w3
	mov	AdcPa_1616, w0
	mov	AdcPa, w1
	mov	#1, w2
	mov	#5, w4
	rcall	i1616Dx6toppc

	mov	#txt_mV, w0
	rcall	ppc_move

	mov	#0, w0
	mov	#23, w1
	bra	LCD_StrBufOut_cs

;	inc	LCD_Step
;	return

Line2:
	cp0	w1			/* max.line-1 == 0 */
	bra	leu, l2_ne

	mov	#EingDac2, w5
	mov	#2, w0
	rcall	md_get_dac_txt
	rcall	DispVxVal

l2_ne:
	mov	#Str_buffer, w3
	mov	GOV_01mV, w0
	mov	#1, w2
	rcall	int16toppc
	mov	#txt_mV, w0
	rcall	ppc_move

	mov	#0, w0
	mov	#33, w1
	bra	LCD_StrBufOut_cs

;	inc	LCD_Step
;	return

Line3:
	cp	w1, #1			/* max.line-1 == 1 */
	bra	leu, l3_ne

	mov	#EingDac3, w5
	mov	#3, w0
	rcall	md_get_dac_txt
	rcall	DispVxVal
l3_ne:
	mov	#Str_buffer, w3
	mov	GRV_01mV, w0
	mov	#1, w2
	rcall	int16toppc
	mov	#txt_mV, w0
	rcall	ppc_move
	mov	#0, w0
	mov	#43, w1
	bra	LCD_StrBufOut_cs

;	inc	LCD_Step
;	return

Line4:
	cp	w1, #2			/* max.line-1 == 2 */
	bra	leu, l4_ne

	mov	#EingDac4, w5
	mov	#4, w0
	rcall	md_get_dac_txt
	rcall	DispVxVal
l4_ne:
	mov	#Str_buffer, w3
	mov	OP1V_1616_001mV, w0
	mov	OP1V_1616_001mV+2, w1
	mov	#2, w2
	mov	#5, w4
	rcall	i1616Dx6toppc


;	mov	OP1V_005mV, w0
;	asr	w0, w0
;	addc	w0, #0, w0
;	mov	#1, w2
;	rcall	int16toppc
	mov	#txt_mV, w0
	rcall	ppc_move
	mov	#0, w0
	mov	#53, w1
	bra	LCD_StrBufOut_cs

;	inc	LCD_Step
;	return

/* ______________________________________________________________________ */
Key_TestDac:
	mov	#EingDac1, w5
	rcall	EingVx_Key

	cp0	akt_max_line		/* max.line-1 == 0 */
	bra	z, ktd_na

	mov	#EingDac2, w5
	rcall	EingVx_Key

	mov	akt_max_line, w1
	cp	w1, #1			/* max.line-1 == 1 */
	bra	z, ktd_na

	mov	#EingDac3, w5
	rcall	EingVx_Key

	mov	akt_max_line, w1
	cp	w1, #2			/* max.line-1 == 2 */
	bra	z, ktd_na

	mov	#EingDac4, w5
	rcall	EingVx_Key
ktd_na:
	cp	w0, #KEY_RET
	bra	z, K_CRet
	return

K_CRet:
	mov	EingVx_CursSelIdx, w0
	and	#EVCURS_SELNR_MASK, w0
	lsr	w0, #EVCURS_SELNR_SHL, w0
	mov	w0, akt_line		/* akt.line */

	mov	#EingClx, w6
	rcall	EingVx_Pop_CursLineIdx

	bra	Key_RetOk_Menu

/* -------------------- GetDAC_txt --------------------------------
Input:  w0=DAC idx
Output: w0=Test Pointer			SR Z == no txt
used; w0:w1:w2
------------------------------------------------------------------- */
GetDAC_txt:
	mov	#tab_dac_txt, w2
	ze	w0, w0
	mov	[w2++], w1
	cp	w0, w1
	bra	geu, no_txt
	sl	w0, w0
	nop
	mov	[w2+w0], w0
	cp0	w0
	return

no_txt:
	clr	w0
	cp0	w0
	return

/* ______________________________________________________________________ */


md_get_dac_txt:
	sl	w0, w0
	mov	pLCD_MenuData, w4
	cp0	w4
	bra	z, gdte_txt
	mov	[w4+w0], w0
	rcall	GetDAC_txt

	bra	z, no_txt
	mov	#Str_buffer, w3
	rcall	ppc_move
	mov	#56, w0
	mov	[w5+oEVX_DISP_Y], w1
	mov	#Str_buffer, w2
	mov	[w5+oEVX_DISP_FLAG], w3
	rcall	StrOut_dvf
gdte_txt:
	btsc	TestFlags, #bTF_DAC
	return
	mov	[w5+oEVX_OWNER], w2
	rcall	DacGetValue_R_Align
	rcall	EingVx_SetValue
	return

init_line:
	push.d	w8

	mov	w0, w9			/* w0= line.idx */
	mov	#0, w1			/* akt.X.pos */
	rcall	EingVx_SetCursSelIdx

	mov	pLCD_MenuData, w4
	sl	w9, w3
	add	w3, w4, w3		/* pData + line offset */
	nop
	mov	[w3+2], w2		/* Dac Id */
	mov	w2, [w5+oEVX_OWNER]

	mov	#DAC_XB_MASK, w0
	and	w2, w0, w8
	lsr	w8, #8, w8		/* bit shift */
	mov	w2, [w5+oEVX_OWNER]
	rcall	DacGetValue		/* w0=dac value */

	mov	[w5+oEVX_OWNER], w2
	btst	w2, #bDAC_SIGN
	bra	nz, il_sign

	btss	w2, #bDAC_R_ALIGN
	lsr	w0, w8, w0
	mov	#0x0000, w2		/* min. */
	mov	#0xFFFF, w3		/* max. */
	lsr	w3, w8, w3
	mov	#0x0511, w4		/* 14,15,16 bit 5 digit */
	cp	w8, #2
	bra	leu, il_svmmdf
	mov	#0x0411, w4		/* 10,11,12,13 bit 4 digit */
	cp	w8, #6
	bra	leu, il_svmmdf
	mov	#0x0311, w4		/* 7,8,9 bit 3 digit */
	bra	il_svmmdf

il_sign:
	btss	w2, #bDAC_R_ALIGN
	asr	w0, w8, w0
	mov	#0x8000, w2		/* min. */
	mov	#0x7FFF, w3		/* max. */
	asr	w2, w8, w2
	lsr	w3, w8, w3
	mov	#0x0510, w4		/* 15,16 bit		5 digit */
	cp	w8, #1
	bra	leu, il_svmmdf
	mov	#0x0410, w4		/* 11,12,13,14 bit	4 digit */
	cp	w8, #5
	bra	leu, il_svmmdf
	mov	#0x0310, w4		/* 8,9,10 bit		3 digit */

il_svmmdf:
	rcall	EingVx_SetValueMinMaxDflag

	mov	#-110, w0		/* X.pos */
	mul.uu	w9, #10, w2
	mov	#23, w1
	add	w1, w2, w1		/* Y.pos */
	mov	#1, w2			/* dig */
	rcall	EingVx_SetDispXYTxt

	mov	psv_Val_OnCange, w0
	rcall	EingVx_Init_OnCange

	btst	TestFlags, #bTF_DAC
	bra	nz, il_teen
	mov	[w5+oEVX_CURS], w0
	bclr	w0, #bEVCURS_ON
	mov	w0, [w5+oEVX_CURS]

il_teen:
	pop.d	w8
	return

.if 0
Val_OnCange: 
	btst	w6, #bDAC_R_ALIGN
	bra	nz, voc_nsl

	mov	#DAC_XB_MASK, w1
	and	w6, w1, w2
	lsr	w2, #8, w2		/* bit shift */
	sl	w0, w2, w0
voc_nsl:
	mov	w6, w2
	rcall	DacSetValue
	return
.endif
/* ______________________________________________________________________ */
.section .const, psv

psv_Val_OnCange:
	.word DacVxOnChange


txdac0:	.asciz	"GLIN0"
txdac1:	.asciz	"LINPA"
txdac2:	.asciz	"GLIN1"
txdac3:	.asciz	"FR0"

txdac4:	.asciz	"GRC"
txdac5:	.asciz	"FR1"
txdac6:	.asciz	"GRP0"
txdac7:	.asciz	"OP1LC"

txdac8:	.asciz	"OPTO"
txdac9:	.asciz	"GTI1"
txda10:	.asciz	"OP1"
txda11:	.asciz	"GTI0"

txda12:	.asciz	"GRN1"
txda13:	.asciz	"GVN"
txda14:	.asciz	"GRN0"
txda15:	.asciz	"GVP"

txda16:	.asciz	"VIMP"
txda17:	.asciz	"OSCT"
txda18:	.asciz	"APSYM"
txda19:	.asciz	"OSYM"

txda20:	.asciz	"AIMP"
txda21:	.asciz	"PAV0"

txda22:	.asciz	"PAPOW"
txda23:	.asciz	"PADC"

txda24:	.asciz	"GLIN"

 .align 2
tab_dac_txt:
	.word 26
	.word txdac0, txdac1, txdac2, txdac3, txdac4, txdac5, txdac6, txdac7
	.word txdac8, txdac9, txda10, txda11, txda12, txda13, txda14, txda15
	.word txda16, txda17, txda18, txda19, txda20, txda21, txda22, txda23
	.word txda24, 0
