/*
 Copyright (C) 2014-2022 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "main.inc"
.include "lib/eingVx.inc"
.include "lib/Analog.inc"
.include "lib/Param.inc"

	EingGRP0 = EingVx0
	EingGRN0 = EingVx1
	EingGRN1 = EingVx2

	EingLIN0 = EingVx3
	EingLIN1 = EingVx4
	EingLINPA = EingVx5

	EingFR0 = EingVx6
	EingFR1 = EingVx7

	EingGRCL = EingVx8
	EingGRCoL = EingVx9

	EingGRCH = EingVx10
	EingGRCoH = EingVx11

.section .nbss, bss, near
/*
EingGRP0:		.space EVX_SIZE
EingGRN0:		.space EVX_SIZE
EingGRN1:		.space EVX_SIZE

EingLIN0:		.space EVX_SIZE
EingLIN1:		.space EVX_SIZE
EingLINPA:		.space EVX_SIZE

EingFR0:		.space EVX_SIZE
EingFR1:		.space EVX_SIZE

EingGRCL:		.space EVX_SIZE
EingGRCoL:		.space EVX_SIZE

EingGRCH:		.space EVX_SIZE
EingGRCoH:		.space EVX_SIZE
*/
Filter_CursLineIdx:	.space 4
;Last_CursLineIdx:	.space 4
Last_CursSelIdx:	.space 2
Filter_fram_data:		.space ((VX_FILTER_COUNT+1) >> 1) << 1

akt_filter_id:		.space 2

.global Filter_fram_data

/* ______________________________________________________________________ */
.section .text

.global LCD_Filter
.global Key_Filter
.global init_FilterPara

.if USE_UART_LIST_PARA
.global get_val_Filter
.endif

LCD_Filter:
	dec	w0, w0
	bra	z, LCD_MenuCaption_cs
	dec	w0, w0
	bra	z, Line1
	dec	w0, w0
	bra	z, Line2
	dec	w0, w0
	bra	z, Line3
	dec	w0, w0
	bra	z, Line4
	dec	w0, w0
	bra	z, Line5
	dec	w0, w0
	bra	z, Line6
	dec	w0, w0
	bra	z, Line7
	dec	w0, w0
	bra	z, Line8
	dec	w0, w0
	bra	z, Line9
	dec	w0, w0
	bra	z, Line10
	dec	w0, w0
	bra	z, Line11
	dec	w0, w0
	bra	z, Line12
	bra	LCD_Paint

/* ______________________________________________________________________ */
Line1:
	mov	#EingGRP0, w5
	bra	Ldispl_val
/* ______________________________________________________________________ */
Line2:
	mov	#EingGRN0, w5
	bra	Ldispl_val
/* ______________________________________________________________________ */
Line3:
	mov	#EingGRN1, w5
	bra	Ldispl_val
/* ______________________________________________________________________ */
Line4:
	mov	#EingLIN0, w5
	bra	Ldispl_val
/* ______________________________________________________________________ */
Line5:
	mov	#EingLIN1, w5
	bra	Ldispl_val
/* ______________________________________________________________________ */
Line6:
	mov	#EingLINPA, w5
	bra	Ldispl_val
/* ______________________________________________________________________ */
Line7:
	mov	#EingFR0, w5
	bra	Ldispl_val
/* ______________________________________________________________________ */
Line8:
	mov	#EingFR1, w5
	bra	Ldispl_val
/* ______________________________________________________________________ */
Line9:
	mov	#EingGRCL, w5
	bra	Ldispl_val
/* ______________________________________________________________________ */
Line10:
	mov	#EingGRCoL, w5
	bra	Ldispl_val
/* ______________________________________________________________________ */
Line11:
	mov	#EingGRCH, w5
	bra	Ldispl_val
/* ______________________________________________________________________ */
Line12:
	mov	#EingGRCoH, w5
	bra	Ldispl_val

Ldispl_val:
	mov	[w5+oEVX_CURS], w0
	btst	w0, #bEVCURS_ON
	bra	z, LCD_Step_Inc

	mov	[w5+oEVX_DISP_FLAG], w1
	mov	[w5+oEVX_DISP_X], w0
	sub	w0, #30, w0
	btsc	w1, #bDVF_IS_UNSIGN
	sub	w0, #5, w0

	mov	[w5+oEVX_DISP_Y], w1
	mov	[w5+oEVX_P_TXT], w2
	rcall	StrOut_cs
	rcall	DispVxVal
	inc	LCD_Step
	return

/* ______________________________________________________________________ */
Key_Filter:
	mov	#EingGRP0, w5
	rcall	EingVx_Key

	mov	#EingGRN0, w5
	rcall	EingVx_Key

	mov	#EingGRN1, w5
	rcall	EingVx_Key

	mov	#EingLIN0, w5
	rcall	EingVx_Key

	mov	#EingLIN1, w5
	rcall	EingVx_Key

	mov	#EingLINPA, w5
	rcall	EingVx_Key

	mov	#EingFR0, w5
	rcall	EingVx_Key

	mov	#EingFR1, w5
	rcall	EingVx_Key

	mov	#EingGRCL, w5
	rcall	EingVx_Key

	mov	#EingGRCoL, w5
	rcall	EingVx_Key

	mov	#EingGRCH, w5
	rcall	EingVx_Key

	mov	#EingGRCoH, w5
	rcall	EingVx_Key

	cp	w0, #KEY_RET
	bra	z, K_CRet
	return

K_CRet:
	mov	EingVx_CursSelIdx, w0
	mov	w0, Last_CursSelIdx

;	mov	#Last_CursLineIdx, w6
;	rcall	EingVx_Push_CursLineIdx

	mov	#Filter_CursLineIdx, w6
	rcall	EingVx_Pop_CursLineIdx

	mov	#VX_FILTER_COUNT, w2
	mov	EingGRP0+oEVX_RAM_DATA_ADR, w0
	mov	#EEData0, w1
	add	w0, w1, w0
	mov	#Filter_fram_data, w1
lloop:
	mov.b	[w0++], w3
	cp.b	w3, [w1++]
	bra	nz, lsave
	dec	w2, w2
	bra	nz, lloop

	bra	Key_RetOk_Menu

lsave:
	mov	akt_filter_id, w2
	mov	#EVCURS_FRAM_MASK, w1
	and	w2, w1, w2

	mov	#VX_FILTER_COUNT-1, w3
	call	FRam_Save
	bra	Key_RetOk_Menu

/* ______________________________________________________________________ */
/* param data pointer w4 */
init_FilterPara:
	mov	#Filter_CursLineIdx, w6
	rcall	EingVx_Push_CursLineIdx

	mov	#EVCURS_FRAM_MASK, w0
	and	w4, w0, w2		; w9=Fram
	mov	#VX_FILTER_COUNT-1, w3
	rcall	FRam_GetAdr
	btsc	SR, #OV
	return
	mov	#Filter_fram_data, w0
	repeat	w3
	mov.b	[w2++], [w0++]

	mov	akt_filter_id, w0
	cp	w0, w4
	bra	z, ifp_ok
	clr	Last_CursSelIdx
	mov	w4, akt_filter_id
ifp_ok:

/*
	mov	akt_filter_id, w0
	cp	w0, w4
	bra	nz, ifp_new

	mov	#Last_CursLineIdx, w6
	rcall	EingVx_Pop_CursLineIdx
	return

ifp_new:
	mov	w4, akt_filter_id
*/
	push.d	w8
	push.d	w10
	push	w12

	mov	#VX_FILTER_COUNT-1, w0		/* max.line-1 */
;	mov	#0, w1				/* akt.line */
	mov	Last_CursSelIdx, w1		/* akt.line */
	and	#EVCURS_SELNR_MASK, w1
	lsr	w1, #EVCURS_SELNR_SHL, w1
	rcall	EingVx_InitCursLineIdx

	mov	#0, w8			; w8=nr
	mov	#EVCURS_FRAM_MASK, w0
	and	w4, w0, w9		; w9=Fram
	mov	#30, w10		; w10=x
	mov	#10, w11		; w11=y

	mov	#tab_dac_filter, w12	; w12=dac

/* EingGRP0 */
	mov	#EingGRP0, w5
	rcall	init_line
/* EingGRN0 */
	mov	#EingGRN0, w5
	rcall	init_line
/* EingGRN1 */
	mov	#EingGRN1, w5
	rcall	init_line
/* EingLIN0 */
	mov	#EingLIN0, w5
	rcall	init_line
/* EingLIN1 */
	mov	#EingLIN1, w5
	rcall	init_line

/* EingLINPA */
	mov	#EingLINPA, w5
	rcall	init_line

	mov	#94, w10		; w10=x
	mov	#10, w11		; w11=y

/* EingFR0 */
	mov	#EingFR0, w5
	rcall	init_line
/* EingFR1 */
	mov	#EingFR1, w5
	rcall	init_line

/* EingGRCL */
	mov	#EingGRCL, w5
	rcall	init_line
	mov	#tFiGRCL, w0
	mov	w0, [w5+oEVX_P_TXT]

/* EingGRCoL */
	mov	#EingGRCoL, w5
	rcall	init_line
	mov	#tFiGRCoL, w0
	mov	w0, [w5+oEVX_P_TXT]

/* EingGRCH */
	mov	#EingGRCH, w5
	rcall	init_line
	mov	#tFiGRCH, w0
	mov	w0, [w5+oEVX_P_TXT]

/* EingGRCoH */
	mov	#EingGRCoH, w5
	rcall	init_line
	mov	#tFiGRCoH, w0
	mov	w0, [w5+oEVX_P_TXT]

	pop	w12
	pop.d	w10
	pop.d	w8
	return

/* w8=nr w9=Fram w10=x w11=y w12=dac */
init_line:

	mov	w8, w0			/* line.idx */
	mov	#0, w1			/* akt.X.pos */
	rcall	EingVx_SetCursSelIdx
	mov	#EVCURS_SELFKT_LEFT, w0
	btsc	w10, #6
	mov	#EVCURS_SELFKT_LEFT64, w0
	rcall	EingVx_SetCursSelFkt

	mov	#Filter_fram_data, w2
	add	w2, w8, w2
	btst	[w12], #bDAC_SIGN
	bra	z, il_no_sign
	se	[w2], w0
	mov	#-128, w2		/* min. */
	mov	#127, w3		/* max. */
	mov	#0x0312, w4
	bra	il_vx_set

il_no_sign:
	ze	[w2], w0
	mov	#0, w2			/* min. */
	mov	#255, w3		/* max. */
	mov	#0x0311, w4
il_vx_set:
	rcall	EingVx_SetValueMinMaxDflag

	mov	w9,  [w5+oEVX_RAM_DATA_ADR]
	mov	w10, w0
	btss	[w12], #bDAC_SIGN
	add	w0, #5, w0
	mov	w0, [w5+oEVX_DISP_X]
	mov	w11, [w5+oEVX_DISP_Y]

	clr	w0
	cp	w8, #8
	bra	ge, il_no_txt

	mov	[w12++], w0
	rcall	GetDAC_txt
il_no_txt:
	mov	w0, [w5+oEVX_P_TXT]

	mov	pg_on_change, w0
	rcall	EingVx_Init_OnCange

	inc	w8, w8
	inc	w9, w9
	add	#9, w11
	return

on_change_filter:
	mov	[w5+oEVX_RAM_DATA_ADR], w2
	mov	#0, w3
	rcall	FRam_SetValue
	rcall	SetUpFilter
	return

/* ______________________________________________________________________ */
.if USE_UART_LIST_PARA
/* w2=LineIdx w7=ParamLine w4=Ext Data */
get_val_Filter:
	cp0	w4
	bra	z, ucMenuSend_NULL

	cp	w2, #VX_FILTER_COUNT
	bra	gtu, ucMenuSend_NULL

	dec	w2, w2
	add	w4, w2, w4
	mov	#EEData0, w0
	add	w4, w0, w4
	cp0	w2
	btss	SR, #Z
	ze	[w4], w0
	btsc	SR, #Z
	se	[w4], w0

	mov	#Str_buffer, w3
	mov	#0, w2
	bra	int16D3toppc

.endif  /* USE_DEBUG_UART_USER */

/* ______________________________________________________________________ */
.section .const, psv
pg_on_change:	.word on_change_filter

tFiGRCL:	.asciz	"GRCL"
tFiGRCoL:	.asciz	"GRCoL"
tFiGRCH:	.asciz	"GRCH"
tFiGRCoH:	.asciz	"GRCoH"
