/*
 Copyright (C) 2014-2022 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "main.inc"
.include "lib/eingVx.inc"
.include "lcd_flags.inc"

.section .nbss, bss, near
FlagsEdStat:		.space 2

edf_fkt:		.space 2
edf_value:		.space 2
edf_value_ed:		.space 2
edf_value_orig:		.space 2

edf_nBit:		.space 2
edf_mask:		.space 2
edf_shift:		.space 2
edf_pvalue:		.space 2
edf_onchange:		.space 2
edf_txt:		.space 2

edf_curs_idx:		.space 2
edf_X_pos:		.space 2

edf_last_p:		.space 2

.global FlagsEdStat

/* ______________________________________________________________________ */
.section .text

.global LCD_Flags
.global Key_Flags
.global FlagsEdInit
.global FlagsEdReloadValue

.if USE_UART_LIST_PARA
.global get_val_Flags
.endif

LCD_Flags:
	dec	w0, w0
	bra	z, LCD_MenuCaption
	dec	w0, w0
	bra	z, ParaStatus
	dec	w0, w0
	bra	z, Line1
	dec	w0, w0
	bra	z, Line2
	dec	w0, w0
	bra	z, Line_io1
	dec	w0, w0
	bra	z, Line_io2
	dec	w0, w0
	bra	z, Line_bottom
	bra	LCD_Paint
ParaStatus:
	rcall	StatusLine
	mov	#0, w0
	mov	#14, w1
	bra	LCD_StrBufOut_cs

Line1:
	btst	FlagsEdStat, #bFES_READ_ONLY
	bra	z, l1_nrl
	clr	w0
	rcall	FlagsEdReloadValue
	mov	#ON_CHANGE_RELOAD, w3
	rcall	edf_on_change
l1_nrl:
	mov	#Str_buffer, w3
	mov	edf_value_ed, w0
	btst	edf_fkt, #bLCDF_BITMOD
	bra	nz, l1_bm

	mov	#0, w2
	rcall	uint16D1toppc
	bra	l1_bm_curs

l1_bm:
	mov	edf_nBit, w2
	subr	w2, #16, w1
	sl	w0, w1, w0
l1_bm_loop:
	mov	#'0', w1
	btsc	w0, #15
	mov	#'1', w1
	mov.b	w1, [w3++]
	sl	w0, w0
	dec	w2, w2
	bra	nz, l1_bm_loop
	clr.b	[w3]

l1_bm_curs:
	mov	edf_X_pos, w0
	mov	#22, w1
	rcall	LCD_StrBufOut8x13

	btsc	FlagsEdStat, #bFES_READ_ONLY
	return
/*
	mov	edf_X_pos, w0		; w0=X
	mov	edf_curs_idx, w1	; w1=curs.idx
	mov	#1, w2			; w2=val.num
	mov	#0x0001, w3		; w3=dvf (bDVF_IS_UNSIGN)

	btst	edf_fkt, #bLCDF_BITMOD
	bra	z, l1_bm_curs_x
	mov	edf_nBit, w2		; w2=val.num
	mov	#0x0005, w3		; w3=dvf (bDVF_IS_UNSIGN | bDVF_IS_1616)
l1_bm_curs_x:
	
	rcall	GetNumCursX_StrBuf
*/

	mov	#0, w1			; w1=len
	btst	edf_fkt, #bLCDF_BITMOD
	bra	z, l1_bm_curs_x
	mov	edf_nBit, w0
	dec	w0, w0
	bra	n, l1_bm_curs_x
	mov	edf_curs_idx, w1
	sub	w0, w1, w1
l1_bm_curs_x:
	mov	#Str_buffer, w2
	mov	edf_X_pos, w0		; w0=X
	rcall	StrLen8x13


	dec	w0, w0			; w0=x
	sub	w1, w0, w2		; w2=w
	mov	#21, w1			; w1=y
;	dec	w1, w1
	mov	#12, w3			; w3=h
	bra	InvRect

Line2:
	cp0	edf_txt
	bra	z, LCD_Step_Inc
	mov	#0, w0
	mov	#38, w1
	mov	edf_txt, w2
	btst	edf_fkt, #bLCDF_TXT_CS
	bra	nz, LCD_ConstStrBufOut_cs
	bra	LCD_ConstStrOut8x13

Line_io1:
	mov	#LCDD_PA, w0
	rcall	DispValId
	bra	z, LCD_Step_Inc

	mov	#0, w0
	mov	#50, w1
	bra	LCD_StrBufOut_cs

Line_io2:
	mov	#LCDD_OP1V, w0
	rcall	DispValId
	bra	z, LCD_Step_Inc

	mov	#66, w0
	mov	#50, w1
	bra	LCD_StrBufOut_cs

Line_bottom:
	mov	#0, w0
	mov	#58, w1
	bra	StrbTemp_cs_step

/* ______________________________________________________________________ */
Key_Flags:
	mov	pLCD_MenuData, w4
	cp	w0, #KEY_UP
	bra	z, K_up
	cp	w0, #KEY_DOWN
	bra	z, K_CDown
	cp	w0, #KEY_LEFT
	bra	z, Key_left
	cp	w0, #KEY_RIGHT
	bra	z, Key_right

	cp	w0, #KEY_RET
	bra	z, K_CRet
	return
K_up:
	btst	FlagsEdStat, #bFES_READ_ONLY
	bra	nz, Key_RetOk
	mov	edf_value_ed, w0
	btst	edf_fkt, #bLCDF_BITMOD
	bra	nz, kup_bm

	inc	w0, w0
	rcall	set_TestVal
	bra	chk_on_change
kup_bm:
	mov	#1, w1
	mov	edf_curs_idx, w2
	sl	w1, w2, w1
	xor	w0, w1, w0
	rcall	set_TestVal
	bra	chk_on_change

K_CDown:
	btst	FlagsEdStat, #bFES_READ_ONLY
	bra	nz, Key_RetOk
	mov	edf_value_ed, w0
	btst	edf_fkt, #bLCDF_BITMOD
	bra	nz, kup_bm
	dec	w0, w0
	rcall	set_TestVal
chk_on_change:
	mov	#ON_CHANGE_VALUE, w3
	rcall	edf_on_change
	bra	Key_RetRePaint

Key_left:
	btst	edf_fkt, #bLCDF_BITMOD
	bra	z, Key_RetOk
	btst	FlagsEdStat, #bFES_READ_ONLY
	bra	nz, Key_RetOk

	mov	edf_nBit, w0
	mov	edf_curs_idx, w1
	inc	w1, w1
	cp	w1, w0
	bra	geu, Key_RetOk
	inc	edf_curs_idx
	bra	Key_RetRePaint

Key_right:
	btst	edf_fkt, #bLCDF_BITMOD
	bra	z, Key_RetOk
	btst	FlagsEdStat, #bFES_READ_ONLY
	bra	nz, Key_RetOk

	cp0	edf_curs_idx
	bra	z, Key_RetOk
	dec	edf_curs_idx
	bra	Key_RetRePaint

K_CRet:
	mov	#ON_CHANGE_CLOSE, w3
	rcall	edf_on_change
	bra	Key_RetOk_Menu

/* w3=stat */
edf_on_change:
	btss	edf_fkt, #bLCDF_ONCANGE
	return
	cp0	edf_onchange
	btsc	SR, #Z
	return

	push	w8
	mov	edf_onchange, w8
	mov	edf_value, w0
	mov	edf_value_ed, w1
	mov	edf_value_orig, w2
	call	w8
	pop	w8
	return

set_TestVal:
	btst	edf_fkt, #bLCDF_BITMOD
	bra	nz, lstv_ok

	mov	edf_fkt, w1
	and	#LCDF_COUNT_MASK, w1
	lsr	w1, #LCDF_COUNT_SHIFT, w1
	cp0	w1
	btsc	SR, #Z
	mov	#1, w1
	btsc	w0, #15
	mov	w1, w0

	cp	w0, w1
	bra	leu, lstv_ok
	clr	w0
lstv_ok:
	mov	w0, edf_value_ed

	mov	edf_shift, w1
	sl	w0, w1, w0

	mov	edf_value, w2
	mov	edf_mask, w1
	com	w1, w1
	and	w2, w1, w2
	ior	w0, w2, w0
	mov	w0, edf_value

	mov	edf_pvalue, w5
	cp0	w5
	bra	z, lste
	mov	w0, [w5]
lste:
	return

/* ______________________________________________________________________ */
/* param data pointer w4 */
FlagsEdInit:
	clr	FlagsEdStat
	mov	edf_last_p, w0
	cp	w0, w4
	btss	SR, #Z
	clr	edf_curs_idx
	mov	w4, edf_last_p

	mov	[w4], w2
	mov	w2, edf_fkt
.if 0
	btst	w2, #bLCDF_BITMOD
	bra	nz, itv_bm
	lsr	w2, #LCDF_COUNT_SHIFT, w2
	mov	#1, w0
	btsc	w2, #1
	mov	#2, w0
	btsc	w2, #2
	mov	#3, w0
	bra	itv_nBit

itv_bm:
	and	#LCDF_COUNT_MASK, w2
	lsr	w2, #LCDF_COUNT_SHIFT, w0
	inc	w0, w0
itv_nBit:
	mov	w0, edf_nBit

	subr	w0, #8, w0
	mov	#0x00FF, w1
	lsr	w1, w0, w1
	mov	[w4], w0
	and	#LCDF_BNR_MASK, w0
	mov	w0, edf_shift
	sl	w1, w0, w1
	mov	w1, edf_mask
.else
	rcall	get_edf_xbit
	mov	w0, edf_nBit
	mov	w1, edf_shift
	mov	w2, edf_mask
.endif

	add	w4, #2, w5
	clr	edf_onchange
	clr	edf_txt
	clr	edf_pvalue
	clr	edf_value_orig

	btst	[w4], #bLCDF_NOVALUE
	bra	nz, itv_oc
	mov	[w5++], w0
	mov	w0, edf_pvalue
	mov	[w0], w0
	mov	w0, edf_value_orig
itv_oc:
	btst	[w4], #bLCDF_ONCANGE
	bra	z, itv_txt
	mov	[w5++], w0
	mov	w0, edf_onchange
itv_txt:
	btst	[w4], #bLCDF_TXT
	bra	z, itv_pe
	mov	[w5++], w0
	mov	w0, edf_txt
itv_pe:
	clr	w0
	rcall	FlagsEdReloadValue

	mov	#60, w0
	mov	w0, edf_X_pos

	mov	edf_value_orig, w0
	mov	#ON_CHANGE_OPEN, w3
	rcall	edf_on_change

	return

/* w4=data pointer   Result w0=edf_nBit w1=edf_shift w2=edf_mask */
get_edf_xbit:
	mov	[w4], w2
;	mov	w2, edf_fkt
	btst	w2, #bLCDF_BITMOD
	bra	nz, itv_bm
	lsr	w2, #LCDF_COUNT_SHIFT, w2
	mov	#1, w0
	btsc	w2, #1
	mov	#2, w0
	btsc	w2, #2
	mov	#3, w0
	bra	itv_nBit

itv_bm:
	and	#LCDF_COUNT_MASK, w2
	lsr	w2, #LCDF_COUNT_SHIFT, w0
	inc	w0, w0
itv_nBit:
;	mov	w0, edf_nBit

	subr	w0, #8, w1
	mov	#0x00FF, w2
	lsr	w2, w1, w2
	mov	[w4], w1
	and	#LCDF_BNR_MASK, w1
;	mov	w0, edf_shift
	sl	w2, w1, w2
;	mov	w2, edf_mask
	return


/* if (edf_pvalue=0) w0=value */
FlagsEdReloadValue:
	mov	edf_pvalue, w5
	cp0	w5
	btss	SR, #Z
	mov	[w5], w0
	mov	w0, edf_value_orig

	mov	w0, edf_value
	mov	edf_mask, w1
	and	w0, w1, w0
	mov	edf_shift, w1
	lsr	w0, w1, w0
	mov	w0, edf_value_ed
	return

/* ______________________________________________________________________ */
.if USE_UART_LIST_PARA
/* w2=LineIdx w7=ParamLine w4=Ext Data */
get_val_Flags:
	cp	w2, #1
	bra	nz, ucMenuSend_NULL

	cp0	w4
	bra	z, ucMenuSend_NULL

	btst	[w4], #bLCDF_NOVALUE
	bra	nz, ucMenuSend_NULL

	rcall	get_edf_xbit
/* w4=data pointer   Result w0=edf_nBit w1=edf_shift w2=edf_mask */

	mov	[w4+2], w3
	cp0	w3
	bra	z, ucMenuSend_NULL

	btst	[w4], #bLCDF_BITMOD
	bra	nz, gvf_bit

	mov	[w4], w2
	btst	w2, #bLCDF_NOVALUE
	bra	nz, ucMenuSend_NULL



	btst	w2, #bLCDF_BITMOD
	bra	nz, ucMenuSend_NULL

	lsr	w2, #LCDF_COUNT_SHIFT, w2
	mov	#1, w0			; edf_nBit
	btsc	w2, #1
	mov	#2, w0
	btsc	w2, #2
	mov	#3, w0

	subr	w0, #8, w0
	mov	#0x00FF, w1
	lsr	w1, w0, w1
	mov	[w4], w0
	and	#LCDF_BNR_MASK, w0	; edf_shift
	sl	w1, w0, w1		; edf_mask

	mov	[w4+2], w2
	cp0	w2
	bra	z, ucMenuSend_NULL
	mov	[w2], w2
	and	w2, w1, w2
	lsr	w2, w0, w0

	mov	#Str_buffer, w3
	mov	#0, w2
	bra	uint16D1toppc

gvf_bit:
	mov	[w3], w2

	subr	w0, #16, w1
	sl	w2, w1, w2

	mov	#Str_buffer, w3
gvf_bit_loop:
	mov	#'0', w1
	btsc	w2, #15
	mov	#'1', w1
	mov.b	w1, [w3++]
	sl	w2, w2
	dec	w0, w0
	bra	nz, gvf_bit_loop
	clr.b	[w3]
	return

.endif  /* USE_UART_LIST_PARA */
