/*
  15  14  13  12  11  10   9   8   7   6   5   4   3   2   1   0
 +---------------+---+---+-------+-------+-------+---+---+---+---+
 |  min/max bit  |   |   |DispExV|       |EingTxt|OC |AZO|OW |OVC| Fkt
 +---------------+---+---+-------+-------+-------+---+---+---+---+
 +---+-----------+---+-----------+-----------+---+---+---+----+--+
 |X-1|    Nk     |   |   Num     |           |Fon|Hex|32 |Byte|US| dvf
 +---+-----------+---+-----------------------+---+---+---+----+--+
 +---------------+---+-------------------------------------------+
 |   Einh txt    | 0 |               FRam Adr.                   | IO FRam Adr.
 +---------------+---+-------------------------------------------+
 +---------------+---+-------------------------------------------+
 |   Einh txt    | 1 |                                           | IO 
 +---------------+---+-------------------------------------------+
 +---------------------------------------------------------------+
 |                 OnCange Pointer                               | OVC=1
 +---------------------------------------------------------------+
 +---------------------------------------------------------------+
 |                 Owner Data                                    | OW=1
 +---------------------------------------------------------------+
 +---------------------------------------------------------------+
 |                 FRAM.Value + Offset                           | AZO=1
 +---------------------------------------------------------------+
 +---------------+---------------+---------------+---------------+
 |               |               |               |  DispValueId  | DispExV=1
 +---------------+---------------+---------------+---------------+

Bit 12..15
	min/max bit Word 0=16Bit ... 15=1Bit
	min/max bit Byte 0=8Bit (+127..-128)... 6=1Bit(+1..-2)

Bit 8..9
	DispExV: 0=Standart  1=Val_4x

Bit 4..5
	EingTxt: 0=NULL  1=Offs:  2=Korr:

Bit 3
	OC=1 OnCange on Open and Close
Bit 0
	OVC=1	OnCange(w0:w1=Value, w3=Size, w6=Owner)

--------------------------- DVF ------------------------------------------
Bit 15	max. Cursorpos Num-1 --> VX_STAT[bEVSTAT_CX_M1]
Bit 11	load FRam16 / 10 -> eing 1616


DispValueId:
	1=PA	2=COV	3=CRV	4=OP1V
	5=+25V
*/

	LCDPA_MINMAX_MASK	= 0xF000
	LCDPA_MINMAX_SHL	= 12

	LCDPA_EINGTXT_MASK	= 0x0030
	LCDPA_EINGTXT_SHL	= 4


	bLCDPA_ONCANGE		= 0
	bLCDPA_OWNER		= 1
	bLCDPA_AZ_OFFSET	= 2
	bLCDPA_OC		= 3

	LCDPA_DISEVX_MASK	= 0x0300
	LCDPA_DISEVX_SHL	= 8

/* --------------------------- DVF -------------------------------------- */
;	bDVF_DP_X10		= 11
;	bDVF_DP_MX1		= 15

/* --------------------------- IO FRam Adr ------------------------------ */
	bLCDPA_IO_REL_RAM	= 11
	LCDPA_IO_TXT_MASK	= 0xF000
	LCDPA_IO_TXT_SHL	= 12

/* DispValueId:
	LCDD_PA			= 1
	LCDD_GOV		= 2
	LCDD_GRV		= 3
	LCDD_OP1V		= 4
	LCDD_24V		= 5

	LCDD_HEX16_V1		= 12
	LCDD_HEX16_V2		= 13
*/
