/*
 Copyright (C) 2014-2022 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"

.section .text

.global AddSat_s12b

/* -------------------- AddSat_s12b --------------------------
Input:  w0=Value	w2= add Value	(Sat 0xF800 - 0x07FF)
Output: w0=Result
used; w0:w1:w2:w3:w4				24 Clk
-------------------------------------------------------------- */

AddSat_s12b:
	asr	w0, #15, w1	/* copy sign w0 */
	asr	w2, #15, w3	/* copy sign w1 */
	add	w0, w2, w0
	addc	w1, w3, w1
	mov	#0xF800, w2
	mov	#0xFFFF, w3
	cp	w0, w2
	cpb	w1, w3
	bra	lt, add_s12b_ov
	mov	#0x07FF, w2
	mov	#0x0000, w3
	cp	w0, w2
	cpb	w1, w3
	bra	gt, add_s12b_ov
	return
add_s12b_ov:
	mov	w2, w0
	return
