/*
 Copyright (C) 2014-2022 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "Analog.inc"

.section .text
.global PWM_SetValue
.global PWM_GetValue

/* w0=Value w2=DAC.id */
PWM_SetValue:
;	mov	#PSYM, w1
;	cp	w2, w1
;	bra	z, set_oc4
	mov	#FAN_PWM, w1
	cp	w2, w1
	bra	z, set_oc3
	cp	w0, w0
	return


;set_oc4:
;	mov	#OC4R, w3
;	mov	#0x00, w1
;	bra	DAC_KorrSetValue

set_oc3:
	cp0	w0
	bra	nz, soc3on
;	PWM_FAN_OFF
	bclr	PWM_FAN_PORT, #PWM_FAN_BIT
	bra	soc3set
soc3on:
;	PWM_FAN_ON
	bset	PWM_FAN_PORT, #PWM_FAN_BIT
soc3set:
	mov	#OC3R, w3	; w3=DacDataPointer
	mov	#0x00, w1	; w1=mask(max.Dac)
	bra	DAC_KorrSetValue

/* w2=DAC.id  result w0=Value*/
PWM_GetValue:
;	mov	#PSYM, w1
;	cp	w2, w1
;	bra	z, get_oc4
	mov	#FAN_PWM, w1
	cp	w2, w1
	bra	z, get_oc3
	clr	w0
	return

;get_oc4:
;	mov	#OC4R, w3
;	mov	#0x00, w1
;	bra	DAC_KorrGetValue

get_oc3:
	mov	#OC3R, w3
	mov	#0x00, w1
	bra	DAC_KorrGetValue
