/*
 Copyright (C) 2014-2022 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"

/*  Use MCP4726_A2 !!! */


.section .nbss, bss, near

MCP4726_OutFlag:		.space 2
dac_channel:			.space 2
MCP4726_Data:			.space 4

.global MCP4726_OutFlag
;.global MCP4726_Data

.section .text
.global MCP4726_INIT
.global MCP4726_Handle
.global MCP4726_i2c_run
.global MCP4726_SetValue
.global MCP4726_GetValue

MCP4726_INIT:
	mov	#0x8000, w0
	mov	w0, MCP4726_Data
	mov	w0, MCP4726_Data+2
	mov	#0x0003, w0
	mov	w0, MCP4726_OutFlag
	return

MCP4726_Handle:
	cp0	i2c2_Lock
	bra	nz, lend

	btst	I2CErrorFlag, #I2C_MCP4726
	bra	nz, lerr

	mov	MCP4726_OutFlag, w0
	ff1r	w0, w4
	cp0	w4
	bra	z, lend
	cp	w4, #2
	bra	gtu, lerr

	dec	w4, w4			/* channel */
	mov	w4, dac_channel
	mov	#1, w0
	sl	w0, w4, w0
	com	w0, w0
	and	MCP4726_OutFlag		/* clr bit */

	sl	w4, w2
	mov	#MCP4726_Data, w3
	add	w3, w2, w3


;	mov	MCP4726_Data, w1
;	lsr	w1, #4, w1
;	mov	#0xc4, w0

	mov	#i2c2_Buf, w2
	mov	[w3], w1
	lsr	w1, #4, w1
	
	swap	w1
	mov.b	w1, [w2++]		/* Data */
	swap	w1
	mov.b	w1, [w2++]

	mov	#2, w1
	mov	w1, i2c2_DataSize

	mov	#0xc4, w0
	mov	dac_channel, w1
	and	#0x01, w1
	sl	w1, w1
	add	w0, w1, w0
	mov	w0, i2c2_id

	mov	#I2C_WRITE, w0
	mov	w0, i2c2_cmd

	clr	i2c2_Flag
	bset	i2c2_Flag, #I2C_bNoADR

	mov	#I2C_MCP4726, w0
	mov	w0, i2c2_Lock
;	clr	MCP4726_OutFlag
lend:
	return

lerr:
	clr	MCP4726_OutFlag
	return

MCP4726_i2c_run:
	mov	i2c2_cmd, w0
	cp0	w0
	bra	nz, chk_err
	clr	i2c2_Lock
	return

chk_err:
	cp	w0, #I2C_ERROR
	bra	z, is_err
	return		/* Wait */

is_err:
	bset	I2CErrorFlag, #I2C_MCP4726
	clr	i2c2_Lock
	return

/* w0=Value w2=DAC */
MCP4726_SetValue:
.if 1
	mov	#MCP4726_Data, w3
	mov	#0x01, w1
	rcall	DAC_KorrSetValue
	btss	SR, #Z
	ior	MCP4726_OutFlag
	return
.else
	mov	0xfff0, w1
	and	w0, w1, w0

	cp	MCP4726_Data
	btsc	SR, #Z
	return

	mov	w0, MCP4726_Data
	bset	MCP4726_OutFlag, #0
	return
.endif

/* w0=Value w2=DAC */
MCP4726_GetValue:
	mov	#MCP4726_Data, w3
	mov	#0x01, w1
	bra	DAC_KorrGetValue
