
.IF I2C_MAX_BUF < 16
.ERROR "MAX_BUF < 16"
.ENDIF

	FR_DATA_SEG_SIZE	= 16
	FR_MAX_DATA_SEG		= 27


.equ DataOk,		0
;.equ DataWR,		1
.equ ParamOk,		2

	oFR_LastValue		= 16
	bFR_LastValue		= 1


	FR_DataSystem		= EEData0
;	FR_LastValue		= EEData0+oFR_LastValue

/* Data 0    DataSystem   16Byte
0="Ok"
1.L=LCD Contrast -16..+15
*/
	oFR_CONTRAST		= 2	/* byte */
	oFR_OT_OSC		= 3	/* byte */
	oFR_OT_GEN		= 4	/* byte */
	oFR_OT_OP1		= 5	/* byte */
	oFR_OT_PA		= 6	/* byte */

	oFR_OSCT		= 8	/* word */
	oFR_OSCT_PC		= 10	/* word */
	oFR_FAN_ON_V		= 12	/* byte */
	oFR_FAN_ON_C		= 13	/* byte */
	oFR_HT_ON_C		= 14	/* byte */

/* Data 1   LastValue   16Byte */
	oFR_LastLineIdx		= 16	/* byte */
	oFR_LastFreq		= 17	/* 3 Byte */
	oFR_LastTime		= 20	/* 3 Byte */
	oFR_LastAmpl		= 23	/* 3 Byte */
	oFR_LastOffs		= 26	/* 5 Byte */

	oFR_LAST_FLAG		= 0x1F	/* Byte */
	bFR_LF_PAOF_SQ_P	= 0
	bFR_LF_PAOF_DC		= 1
	bFR_LF_K60CM		= 4
	bFR_LF_NS		= 5	/* 3 Bit */

	bFR_RUN_TIME		= 2
	oFR_RUN_TIME		= 0x2C	/* 4 Byte */

/* Data 3   Dac Data */
	oFR_OSYM		= 0x30	/* word */
	oFR_OSYM_115MHZ		= 0x32	/* word */
	oFR_APSYM		= 0x34	/* word */
	oFR_AGTI0		= 0x36	/* word */
	oFR_AGTI1		= 0x38	/* word */

	oFR_OFF_OP1		= 0x3A	/* word */
	oFR_PA_OFFS_V_KORR	= 0x3C	/* word */
	oFR_OFF_PA_DC		= 0x3E	/* word */
	oFR_OFF_PA_POW		= 0x40	/* word */
	oFR_OFF_OPT		= 0x42	/* word */

	oFR_ADC_OP1_KORR_P	= 0x46	/* word */
	oFR_TC_OP1		= 0x48	/* word */

	oFR_OFF_PA		= 0x4A	/* byte 0.01 mV */
	oFR_OFF_PAEDC		= 0x4B	/* byte 0.01 mV (OFF_PA + OFF_PAEDC) */
	oFR_TC_PA_OUT		= 0x4C	/* byte 0.01 mV/C*/
	oFR_ADC_OP1_KORR_N	= 0x4D	/* byte */
	oFR_TC_OPT		= 0x4E	/* word */

/* Data 5   Dac Data */
	oFR_GAIN_PA		= 0x50	/* word (idx 0) */
	oFR_GAIN_02DB		= 0x52	/* word (idx 2) */
	oFR_GAIN_04DB		= 0x54	/* word (idx 4) */
	oFR_GAIN_08DB		= 0x56	/* word (idx 6) */
	oFR_GAIN_16DB		= 0x58	/* word (idx 8) */
	oFR_GAIN_32DB		= 0x5A	/* word (idx 10) */

	oFR_GENV_HP		= 0x5C	/* word (idx 0) */
	oFR_GENV_HN		= 0x5E	/* word (idx 2) */
	oFR_GENV_LP		= 0x60	/* word (idx 4) */
	oFR_GENV_LN		= 0x62	/* word (idx 6) */
	oFR_GENV_HP_1DB		= 0x64	/* word (idx 8) */
	oFR_GENV_HN_1DB		= 0x66	/* word (idx 10) */
	oFR_GENV_LP_1DB		= 0x68	/* word (idx 12) */
	oFR_GENV_LN_1DB		= 0x6A	/* word (idx 14) */

	oFR_GAIN_KFILT		= 0x6C	/* word */
	oFR_GAIN_K60CM		= 0x6E	/* word */

/* Data 7   */
	oFR_ADCH_PA_OFFS	= 0x70	/* word */
.if ADC_PA_MCP3421_AUTORANGE
	oFR_ADCL_PA_OFFS	= 0x72	/* word */
.endif

	oFR_ADCH_PA_KORR_P	= 0x74	/* word */
.if ADC_PA_MCP3421_AUTORANGE
	oFR_ADCL_PA_KORR_P	= 0x76	/* word */
.endif

	oFR_ADCH_PA_KORR_N	= 0x78	/* byte */
.if ADC_PA_MCP3421_AUTORANGE
	oFR_ADCL_PA_KORR_N	= 0x79	/* byte */
.endif

	oFR_ADCH_PA_K_TC	= 0x7A	/* byte */
.if ADC_PA_MCP3421_AUTORANGE
	oFR_ADCL_PA_K_TC	= 0x7B	/* byte */
.endif

	oFR_ADC_OP1_OFFS	= 0x7C	/* word */
	oFR_PA_POW_V_KORR	= 0x7E	/* word */
	oFR_PA_DC_V_KORR	= 0x80	/* word */

	oFR_DAC_POW_TC		= 0x82	/* byte */
	oFR_DAC_DC_TC		= 0x83	/* byte */
	oFR_ADC_OP1_TC		= 0x84	/* byte */
	oFR_ADC_OP1_K_TC	= 0x85	/* byte */
	oFR_ADC_PA_TC		= 0x86	/* byte */

	oFR_TC_GENV_HP		= 0x88	/* byte */
	oFR_TC_GENV_HN		= 0x89	/* byte */
	oFR_TC_GENV_LP		= 0x8A	/* byte */
	oFR_TC_GENV_LN		= 0x8B	/* byte */
	oFR_TC_GENV_HP_1DB	= 0x8C	/* byte */
	oFR_TC_GENV_HN_1DB	= 0x8D	/* byte */
	oFR_TC_GENV_LP_1DB	= 0x8E	/* byte */
	oFR_TC_GENV_LN_1DB	= 0x8F	/* byte */

/* Data 9   Puls Data */
	oFR_PULS_2NS		= 0x90	/* word */
	oFR_PULS_7NS		= 0x92	/* word */
	oFR_PULS_7NS1		= 0x94	/* word */
	oFR_PULS_19NS9		= 0x96	/* word */
	oFR_PULS_20NS		= 0x98	/* word */
	oFR_PULS_99NS		= 0x9A	/* word */
	oFR_PULS_100NS		= 0x9C	/* word */
	oFR_PULS_319NS		= 0x9E	/* word */
	oFR_PULS_320NS		= 0xA0	/* word */
	oFR_PULS_999NS		= 0xA2	/* word */
	oFR_PULS_1US		= 0xA4	/* word */
	oFR_PULS_3US99		= 0xA6	/* word */
	oFR_PULS_4US		= 0xA8	/* word */
	oFR_PULS_9US99		= 0xAA	/* word */
	oFR_PULS_10US		= 0xAC	/* word */
	oFR_PULS_62US5		= 0xAE	/* word */

/* Data 11   AD5667 0 LinKorr */
	oFR_AD5667_0_LK		= 0xB0	/* 16 Bit */
	oFR_AD5667_1_LK		= 0xC0	/* 16 Bit */

/* Data 13   Setting (Impedanz) */
	oFR_IMPEDANZ		= 0xD0	/* 3 byte */
	oFR_FILT_GENP_LT	= 0xD4	/* byte */
	oFR_FILT_GENP_LT_TIME	= 0xD5	/* byte */
	oFR_FILT_GENN_LT	= 0xD6	/* byte */
	oFR_FILT_GENN_LT_TIME	= 0xD7	/* byte */



	oFR_GEN_H_0DB_SYM	= 0xEC	/* byte */
	oFR_GEN_L_0DB_SYM	= 0xED	/* byte */
	oFR_GEN_H_1DB_SYM	= 0xEE	/* byte */
	oFR_GEN_L_1DB_SYM	= 0xEF	/* byte */

/* Data 15   Sym Data */
	MAX_SYM_DATA		= 24
	oFR_SYM_DATA		= 0xF0	/* byte * 48 */

/* Data 18   Filter Data */
	oFR_GEN_H_0DB_TC	= 0x120		/* byte */
	oFR_GEN_L_0DB_TC	= 0x121		/* byte */
	oFR_GEN_H_1DB_TC	= 0x122		/* byte */
	oFR_GEN_L_1DB_TC	= 0x123		/* byte */
	oFR_OP1LC		= 0x124		/* byte */


	VX_FILTER_COUNT		= 12

	oFR_FILT_10ns		= 0x128		/* 12 byte */
	oFR_FILT_12ns		= oFR_FILT_10ns + VX_FILTER_COUNT  /* 0x134 */
	oFR_FILT_15ns		= oFR_FILT_12ns + VX_FILTER_COUNT  /* 0x140 */
	oFR_FILT_18ns		= oFR_FILT_15ns + VX_FILTER_COUNT  /* 0x14C */
	oFR_FILT_20ns		= oFR_FILT_18ns + VX_FILTER_COUNT  /* 0x158 */
	oFR_FILT_max		= oFR_FILT_20ns + VX_FILTER_COUNT  /* 0x164 */

	VXF_10ns_K0_COUNT	= 5
	oFR_FILT_10ns_K1	= oFR_FILT_max + VX_FILTER_COUNT   /* 0x170 */
	oFR_FILT_10ns_K2	= oFR_FILT_10ns_K1 + VXF_10ns_K0_COUNT   /* 0x175 */
	oFR_FILT_10ns_K3	= oFR_FILT_10ns_K2 + VXF_10ns_K0_COUNT   /* 0x17A */
	oFR_FILT_10ns_K4	= oFR_FILT_10ns_K3 + VXF_10ns_K0_COUNT   /* 0x17F */
	oFR_FILT_10ns_K5	= oFR_FILT_10ns_K4 + VXF_10ns_K0_COUNT   /* 0x184 */
	oFR_FILT_10ns_K6	= oFR_FILT_10ns_K5 + VXF_10ns_K0_COUNT   /* 0x189 */
	oFR_FILT_10ns_K7	= oFR_FILT_10ns_K6 + VXF_10ns_K0_COUNT   /* 0x18E */
	oFR_FILT_12ns_K0	= oFR_FILT_10ns_K7 + VXF_10ns_K0_COUNT   /* 0x193 */
	oFR_FILT_12ns_K1	= oFR_FILT_12ns_K0 + VXF_10ns_K0_COUNT   /* 0x198 */
	oFR_FILT_12ns_K2	= oFR_FILT_12ns_K1 + VXF_10ns_K0_COUNT   /* 0x19D */
	oFR_FILT_12ns_K3	= oFR_FILT_12ns_K2 + VXF_10ns_K0_COUNT   /* 0x1A2 */
					/* 0x1A7 */
