/*
 Copyright (C) 2014-2022 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"

.section .text

.global div_s32_u16_1616

/* -------------------- div_s32_u16_1616 --------------------------
Input:	w0:w1 / w2
Output: w0:w1
used:   w0:w1:w2:w3			220 .. 254 Clk
------------------------------------------------------------ */
div_s32_u16_1616:
	cp0	w2
	bra	z, lerr
	clr	w3
	btst	w1, #15
	bra	z, ds32u16p
	subr	w0, #0, w0
	subbr	w1, #0, w1

	repeat	#17		/* div 32/16->32 */
	div.ud	w0, w2
	exch	w0, w3
	repeat	#17
	div.ud	w0, w2
	subr	w0, #0, w0
	subbr	w3, #0, w1
	return
ds32u16p:
	repeat	#17		/* div 32/16->32 */
	div.ud	w0, w2
	exch	w0, w3
	repeat	#17
	div.ud	w0, w2
	mov	w3, w1		/* result w0,w1 */
	return
lerr:
	clr	w0
	clr	w1
	return
