/*
 Copyright (C) 2014-2023 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "libald.inc"
.include "eingVx.inc"


.if oEVX_STAT
.ERROR  "oEVX_STAT not null"
.endif


.section .nbss, bss, near
EingVx_CursSelIdx:	.space 2
EingVx_CursSelIdxMax:	.space 2
	ECSI_PROP_SEL		= 15

EingVx0:		.space EVX_SIZE
EingVx1:		.space EVX_SIZE
EingVx2:		.space EVX_SIZE

EingVx3:		.space EVX_SIZE
EingVx4:		.space EVX_SIZE
EingVx5:		.space EVX_SIZE

EingVx6:		.space EVX_SIZE
EingVx7:		.space EVX_SIZE

EingVx8:		.space EVX_SIZE
EingVx9:		.space EVX_SIZE

EingVx10:		.space EVX_SIZE
EingVx11:		.space EVX_SIZE

.global EingVx_CursSelIdx


.global EingVx0
.global EingVx1
.global EingVx2
.global EingVx3

.global EingVx4
.global EingVx5
.global EingVx6
.global EingVx7

.global EingVx8
.global EingVx9
.global EingVx10
.global EingVx11

/* ______________________________________________________________________ */
.section .text
.global dvf_to_ppc
.global DispVxVal
.global EingVx_SetDispX
.global EingVx_InitCursLineIdx
.global EingVx_Push_CursLineIdx
.global EingVx_Pop_CursLineIdx
.global EingVx_SetCursSelIdx
.global EingVx_SetCursSelFkt
.global EingVx_GetAktXpos
.global EingVx_SetDispXYTxt
.global EingVx_SetTxt
.global EingVx_SetDispFlag
.global EingVx_SetValueMinMaxDflag
.global EingVx_SetValueMinMax
.global EingVx_SetValue
.global EingVx_GetValue
.global EingVx_DecXCursor
.global EingVx_IncXCursor
.global EingVx_SetXCursor
.global EingVx_Key
.global EingVx_DoChange
.global EingVx_Init_OnCange

.global GetNumCursX_StrBuf

/* 
w0=X w1=curs.idx w2=val.num w3=dvf
*/
GetNumCursX_StrBuf:
	push.d	w8
	mov	#5, w8
	btst	w3, #bDVF_DISP_05
	bra	nz, gcx_inc
	btst	w3, #bDVF_IS_1616
	bra	z, no_1616
gcx_inc:
	inc	w8, w8
	inc	w2, w2
no_1616:
	cpsgt	w8, w2
	mov	w8, w2
	dec	w2, w2
	btsc	w2, #15
	clr	w2

	cpsgt	w2, w1
	mov	w2, w1

	mov	#Str_buffer, w8
	btss	w3, #bDVF_IS_UNSIGN
	inc	w8, w8

	mov	#0x2E, w9
	cp	w1, w2
	bra	z, gcx_ce
gcx_loop:
	cp.b	w9, [w8++]
	bra	z, gcx_loop
	inc	w1, w1
	cp	w1, w2
	bra	nz, gcx_loop
gcx_ce:
	cp.b	w9, [w8]
	btsc	SR, #Z
	inc	w8, w8

	mov	#Str_buffer, w2
	sub	w8, w2, w1
	pop.d	w8
	bra	StrLen_dvf

/* -------------------- dvf_to_ppc -----------------------------
Input:  w0=Val.pointer   w2=DVF   w3=Str_buffer.pointer

Output: w0:w1  w2=AbsAdr		ERROR: SR OV set
used; w0:w1:w2					 Clk
-------------------------------------------------------------- */

dvf_to_ppc:
	push	w5
	mov	w2, w5
	lsr	w5, #DVF_NUM_SIFT, w4
	and	#DVF_NUM_MASK, w4
	lsr	w5, #DVF_NK_SIFT, w2
	and	#DVF_NK_MASK, w2


	btst	w5, #bDVF_IS_1616
	bra	nz, dvtp1616

	btst	w5, #bDVF_IS_BYTE
	bra	nz, dvtp8

	btst	w0, #0
	bra	nz, dvtp16_w0ua
	mov	[w0], w0
dvtp16_w0:
	btst	w5, #bDVF_DISP_05
	bra	nz, dvtp16_05_w0
	btst	w5, #bDVF_IS_UNSIGN
	pop	w5
	bra	z, i16toppc
	bra	u16toppc
dvtp16_05_w0:
	btst	w5, #bDVF_IS_UNSIGN
	pop	w5
	bra	z, i16_05toppc
	bra	u16toppc

dvtp16_w0ua:
	push	w6
	mov.b	[w0+1], w6
	swap	w6
	mov.b	[w0], w6
	mov	w6, w0
	pop	w6
	bra	dvtp16_w0

dvtp8:
	ze	[w0], w0
	btss	w5, #bDVF_IS_UNSIGN
	se	w0, w0
	btst	w5, #bDVF_IS_UNSIGN
	pop	w5
	bra	z, i16toppc
	bra	u16toppc

dvtp1616:
	btst	w0, #0
	bra	nz, dvtp1616_w0ua
	mov	[w0+2], w1
	mov	[w0], w0
dvtp1616_w0:
	btst	w5, #bDVF_IS_BYTE
	bra	nz, dvtp1616_16
	btst	w5, #bDVF_IS_UNSIGN
	pop	w5
	bra	z, i1616Dx6toppc
	bra	u1616Dx6toppc

dvtp1616_16:
	btst	w5, #bDVF_IS_UNSIGN
	pop	w5
	bra	z, i1616toppc
	bra	u1616toppc

dvtp1616_w0ua:
	push	w6
	mov.b	[w0+3], w1
	swap	w1
	mov.b	[w0+2], w1
	mov.b	[w0+1], w6
	swap	w6
	mov.b	[w0], w6
	mov	w6, w0
	pop	w6
	bra	dvtp1616_w0


/* w5=Vx.pointer */
DispVxVal:
	btst	[w5], #bEVSTAT_ERROR
	bra	nz, dvv_pt_err

	btst	[w5], #bEVSTAT_ONLY_TXT
	bra	nz, dvv_only_txt

	rcall	ValueToStrBuf
	mov	[w5+oEVX_P_TXT], w0
	cp0	w0
	bra	z, dvv_notxt
	mov	[w5+oEVX_CURS], w1
	btst	w1, #bEVCURS_ADD_TXT
	bra	z, dvv_notxt
dvv_err:
	mov	#0x82, w1
	mov.b	w1, [w3++]
	rcall	ppc_move
dvv_notxt:
	mov	[w5+oEVX_DISP_X], w0
	mov	[w5+oEVX_DISP_Y], w1
	mov	#Str_buffer, w2
	mov	[w5+oEVX_DISP_FLAG], w3
	rcall	StrOut_dvf

	mov	[w5+oEVX_CURS], w0
	and	#EVCURS_SELNR_MASK, w0
	mov	EingVx_CursSelIdx, w1
	and	#EVCURS_SELNR_MASK, w1
	cp	w0, w1
	bra	nz, dvv_ret

	btst	[w5], #bEVSTAT_ONLY_TXT
	bra	nz, dvv_only_txt_sel

	btst	EingVx_CursSelIdx, #ECSI_PROP_SEL
	bra	nz, dvv_prop_sel

	mov	[w5+oEVX_CURS], w1
	btst	w1, #bEVCURS_ON
	bra	z, dvv_ret
/* Cursor on */

	and	#EVCURS_POS_MASK, w1
	mov	[w5+oEVX_DISP_X], w0
	dec	w0, w0
	mov	[w5+oEVX_DISP_FLAG], w3
	lsr	w3, #DVF_NUM_SIFT, w2
	and	#DVF_NUM_MASK, w2

	rcall	GetNumCursX_StrBuf

	sub	w1, w0, w2
	inc	w2, w2
	bra	dvv_inv_y

dvv_prop_sel:
	mov	[w5+oEVX_CURS], w0
	mov	#EVCURS_SELFKT_MASK, w1
	and	w0, w1, w0
	bra	z, dvv_prop_rigth
	lsr	w0, #EVCURS_SELFKT_SHL, w0

	cp	w0, #EVCURS_SELFKT_LEFT
	bra	z, dvv_prop_left
	cp	w0, #EVCURS_SELFKT_LEFT64
	bra	nz, dvv_prop_rigth

dvv_prop_left:
	rcall	VxStrLen
	mov	[w5+oEVX_DISP_X], w1
	bclr	w1, #6
	add	w0, w1, w2	; sel len + offset
	mov	[w5+oEVX_DISP_X], w0
	sub	w0, w1, w0
	bra	dvv_inv_y

dvv_prop_rigth:
	mov	[w5+oEVX_DISP_X], w0
	dec	w0, w0
	mov	#128, w2
	sub	w2, w0, w2
dvv_inv_y:
	mov	[w5+oEVX_DISP_FLAG], w4
	mov	[w5+oEVX_DISP_Y], w1
	dec	w1, w1
	mov	#12, w3
	btsc	w4, #bDVF_FONT
	mov	#8, w3

	bra	InvRect

dvv_ret:
	return

dvv_only_txt:
	mov	[w5+oEVX_P_TXT], w0
	cp0	w0
	bra	z, dvv_ret
	mov	[w5+oEVX_VALUE], w1
	sl	w1, w1
	add	w0, w1, w2
	mov	#Str_buffer, w3
	mov	[w2], w0
	rcall	ppc_move
	bra	dvv_notxt

dvv_only_txt_sel:
	mov	[w5+oEVX_CURS], w1
	btst	w1, #bEVCURS_ON
	bra	z, dvv_ret

	mov	#0, w1
	btsc	EingVx_CursSelIdx, #ECSI_PROP_SEL
	mov	#6, w1

	rcall	VxStrLen_w1
	inc	w1, w2
	mov	[w5+oEVX_DISP_X], w0
	dec	w0, w0
	bra	dvv_inv_y

dvv_pt_err:
	mov	#txt_VxErr, w0
	mov	#Str_buffer, w3
	bra	dvv_err

VxStrLen:
	mov	#8, w1
VxStrLen_w1:
	clr	w0
	mov	#Str_buffer, w2
	mov	[w5+oEVX_DISP_FLAG], w3
	bra	StrLen_dvf

ValueToStrBuf:
	mov	#Str_buffer, w3
	mov	[w5+oEVX_DISP_FLAG], w2
	add	w5, #oEVX_VALUE, w0
	btsc	w2, #bDVF_IS_1616
	dec2	w0, w0		/* ->  oEVX_VALUE_1616 */
	bra	dvf_to_ppc



EingVx_SetDispX:
	push	w4
	push	w0
	rcall	ValueToStrBuf
;	mov	[w5+oEVX_DISP_FLAG], w3
;	mov	#Str_buffer, w2
;	mov	#8, w1
;	clr	w0
;	rcall	StrLen_dvf
	rcall	VxStrLen
	pop	w2
	neg	w2, w2
	sub	w2, w0, w2
	mov	w2, [w5+oEVX_DISP_X]
	pop	w4
	return


/* w0=max.line  w1=akt.line */
EingVx_InitCursLineIdx:
	cpsgt	w0, w1
	mov	w0, w1

	sl	w0, #EVCURS_SELNR_SHL, w0
	and	#EVCURS_SELNR_MASK, w0
	mov	w0, EingVx_CursSelIdxMax

	sl	w1, #EVCURS_SELNR_SHL, w1
	and	#EVCURS_SELNR_MASK, w1
	mov	w1, EingVx_CursSelIdx
	return


/* w5=Vx.pointer w6=Idx.pointer (4byte !!!) */
EingVx_Push_CursLineIdx:
	mov	EingVx_CursSelIdx, w0
	mov	w0, [w6]
	mov	EingVx_CursSelIdxMax, w0
	mov	w0, [w6+2]
	return

/* w5=Vx.pointer w6=Idx.pointer (4byte !!!) */
EingVx_Pop_CursLineIdx:
	mov	[w6], w0
	mov	w0, EingVx_CursSelIdx
	mov	[w6+2], w0
	mov	w0, EingVx_CursSelIdxMax
	return


/* w0=line.idx  w1=akt.X.pos  w5=Vx.pointer */
EingVx_SetCursSelIdx:
	sl	w0, #EVCURS_SELNR_SHL, w0
	and	#EVCURS_SELNR_MASK, w0
	and	#EVCURS_POS_MASK, w1
	ior	w0, w1, w0

	bset	w0, #bEVCURS_ON
	mov	w0, [w5+oEVX_CURS]
	clr	[w5]
	return

/* w0=Fkt  w5=Vx.pointer */
EingVx_SetCursSelFkt:
	sl	w0, #EVCURS_SELFKT_SHL, w0
	mov	#EVCURS_SELFKT_MASK, w1
	and	w0, w1, w0
	mov	[w5+oEVX_CURS], w1
	ior	w0, w1, w0
	mov	w0, [w5+oEVX_CURS]
	return

/* w5=Vx.pointer result w0=akt.X.pos */
EingVx_GetAktXpos:
	mov	[w5+oEVX_CURS], w0
	and	#EVCURS_POS_MASK, w0
	return


/* -------------------- EingVx_SetDispXYTxt -----------------------
w0=X.pos  if w0 neg  -w0 - StrLen = X.pos
w1=Y.po 
W2=0..15 txt num 0=NULL
w5=Vx.pointer
------------------------------------------------------------------- */
EingVx_SetDispXYTxt:
	mov	w0, [w5+oEVX_DISP_X]
	mov	w1, [w5+oEVX_DISP_Y]
	mov	w2, w0
	rcall	EingVx_SetTxt
	mov	[w5+oEVX_DISP_X], w0
	btst	w0, #15
	bra	nz, EingVx_SetDispX
	return


/* w0=0 .. 15 txt nr.  w5=Vx.pointer */
EingVx_SetTxt:
	cp	w0, #15
	bra	gtu, ev_txt0
	cp0	w0
	bra	z, ev_txt0
	sl	w0, #2, w0
	mov	#txt_Einh, w1
	add	w0, w1, w0
	add	w5, #oEVX_CURS, w1
	mov	w0, [w5+oEVX_P_TXT]		; Ram_pText
	bset	[w1], #bEVCURS_ADD_TXT
	return
ev_txt0:
	clr	w0
	mov	w0, [w5+oEVX_P_TXT]		; Ram_pText
	return

/* -------------------- EingVx_SetDispFlag -----------------------
 + test EVX_CURS CursX pos. ok
Input:  w4=EVX_DISP_FLAG	w5=Vx.pointer

used;   w2:w3
------------------------------------------------------------------- */
EingVx_SetDispFlag:
	push.d	w0
	mov	w4, [w5+oEVX_DISP_FLAG]

	mov	[w5+oEVX_CURS], w0
	and	w0, #EVCURS_POS_MASK, w0

	rcall	EingVx_SetXCursor
	pop.d	w0
	return

/* w0:w1=Value w2=min w3=max w4=DISP_FLAG w5=Vx.pointer */
EingVx_SetValueMinMaxDflag:
	mov	w2, [w5+oEVX_DISP_MIN]
	mov	w3, [w5+oEVX_DISP_MAX]
	rcall	EingVx_SetDispFlag
	bra	EingVx_SetValue


/* w0:w1=Value w2=min w3=max  w5=Vx.pointer */
EingVx_SetValueMinMax:
	mov	w2, [w5+oEVX_DISP_MIN]
	mov	w3, [w5+oEVX_DISP_MAX]

; --> EingVx_SetValue();

/* -------------------- EingVx_SetValue ------------------------
Input:  w0:w1=Value	w5=Vx.pointer

Output: 				ERROR (min|max): SR C set
used; w0:w1:w2:w3:w6:w7
-------------------------------------------------------------- */
EingVx_SetValue:
	mov	[w5+oEVX_DISP_FLAG], w2
	btst	w2, #bDVF_IS_1616
	bra	nz, elvs_1616
	mov	w0, w1
	clr	w0
elvs_1616:
	clr	w4
	btss	w2, #bDVF_IS_UNSIGN
	bset	w4, #bADDSUB_MM_SIGN
	mov	[w5+oEVX_DISP_MIN], w6
	mov	[w5+oEVX_DISP_MAX], w7
	rcall	AddSub1616_MinMax
	mov	w0, [w5+oEVX_VALUE_1616]
	mov	w1, [w5+oEVX_VALUE]
	return

/* -------------------- EingVx_GetValue ------------------------
Input:  w5=Vx.pointer

Output: w0:w1
used; w0:w1
-------------------------------------------------------------- */
EingVx_GetValue:
	mov	[w5+oEVX_DISP_FLAG], w1
	btst	w1, #bDVF_IS_1616
	bra	nz, gv1616
	btst	w1, #bDVF_IS_UNSIGN
	bra	nz, gvu16
	mov	[w5+oEVX_VALUE], w0
	asr	w0, #15, w1
	return
gvu16:
	mov	[w5+oEVX_VALUE], w0
	clr	w1
	return

gv1616:
	mov	[w5+oEVX_VALUE_1616], w0
	mov	[w5+oEVX_VALUE], w1
	return


/* w4=inc/dec w5=Vx.pointer */
EingVx_IncDec:
	mov	[w5+oEVX_DISP_FLAG], w1
	btss	w1, #bDVF_IS_UNSIGN
	bset	w4, #bADDSUB_MM_SIGN
	mov	[w5+oEVX_CURS], w0
	and	#EVCURS_POS_MASK, w0
	btst	w1, #bDVF_IS_1616
	bra	z, eid_no_1616
	dec	w0, w0
	btst	w0, #15
	bra	z, eid_no_1616

	mov	#6554, w2	/* add/sub 0.100006 */
	clr	w3
	bra	eid_n

eid_no_1616:
	clr	w2

	btst	w1, #bDVF_DISP_05
	bra	nz, eid_n_t05

	mov	#10000, w3
	cp	w0, #4
	bra	z, eid_n
	mov	#1000, w3
	cp	w0, #3
	bra	z, eid_n
	mov	#100, w3
	cp	w0, #2
	bra	z, eid_n
	mov	#10, w3
	cp	w0, #1
	bra	z, eid_n
	mov	#1, w3
	bra	eid_n
eid_n_t05:
	mov	#2000, w3
	cp	w0, #4
	bra	z, eid_n
	mov	#200, w3
	cp	w0, #3
	bra	z, eid_n
	mov	#20, w3
	cp	w0, #2
	bra	z, eid_n
	mov	#2, w3
	cp	w0, #1
	bra	z, eid_n
	mov	#1, w3
eid_n:
	mov	[w5+oEVX_VALUE_1616], w0
	mov	[w5+oEVX_VALUE], w1
	mov	[w5+oEVX_DISP_MIN], w6
	mov	[w5+oEVX_DISP_MAX], w7
	rcall	AddSub1616_MinMax
	bra	c, eid_err

	lsr	w0, #12, w2
	cp	w2, #0x01	/* 0.0625 .. 0.125  sync to 0.1 */
	btsc	SR, #Z
	mov	#0x199a, w0	; sync 0.1

	cp	w2, #0x0e	/* 0.875 .. 0.937  sync to 0.9 */
	btsc	SR, #Z
	mov	#0xe666, w0	; sync 0.9

eid_change:
	mov	w0, [w5+oEVX_VALUE_1616]
	mov	w1, [w5+oEVX_VALUE]

;eid_xxx:
	bset	[w5], #bEVSTAT_VAL_CHANGE
	btss	[w5], #bEVSTAT_ONCHANGE
	return
	clr	w3
	mov	[w5+oEVX_OWNER], w6
	bra	EingVx_DoChange
/*
	mov	[w5+oEVX_ON_VAL_CHANGE], w3
	btst	w3, #0
	bra	nz, eid_end
	mov	#0x01ff, w0
	cp	w3, w0
	bra	leu, eid_end
;eid_OnchangeOk:
	push	w5
	mov	[w5+oEVX_DISP_FLAG], w2

	mov	[w5+oEVX_VALUE_1616], w0
	mov	[w5+oEVX_VALUE], w1
	btss	w2, #bDVF_IS_1616
	mov	w1, w0
	mov	[w5+oEVX_OWNER], w6
	call	w3
	pop	w5
eid_end:
	return
*/
eid_err:
	btsc	w4, #bADDSUB_MM_OV
	bset	[w5], #bEVSTAT_OV_MAX
	btss	w4, #bADDSUB_MM_OV
	bset	[w5], #bEVSTAT_UV_MIN
	btss	[w5], #bEVSTAT_OV_SET_MAX
	return
	mov	[w5+oEVX_VALUE_1616], w2
	mov	[w5+oEVX_VALUE], w3
	cp	w0, w2
	bra	nz, eid_change
	cp	w1, w3
	bra	nz, eid_change
	return

/* -------------------- EingVx_DoCahange -----------------------
Input:	w3  0=Value Change  1=open  2=close
	w5  Vx.pointer
	w6  Owner
-------------------------------------------------------------- */

EingVx_DoChange:
	push	w8
	mov	[w5+oEVX_ON_VAL_CHANGE], w8
	btst	w8, #0
	bra	nz, dc_pop_w8
	mov	#0x01ff, w0
	cp	w8, w0
	bra	leu, dc_pop_w8

	mov	[w5+oEVX_VALUE_1616], w0
	mov	[w5+oEVX_VALUE], w1
	mov	[w5+oEVX_DISP_FLAG], w2
	btss	w2, #bDVF_IS_1616
	mov	w1, w0
	push	w5
	call	w8
	pop	w5
dc_pop_w8:
	pop	w8
	return

/* -------------------- EingVx_DecXCursor -----------------------
Input:  w5=Vx.pointer

Output: w0=akt CursX pos.
	SR	Z no Change  SR=NZ Change
used;   w0:w1:w2:w3
-------------------------------------------------------------- */
EingVx_DecXCursor:
	mov	[w5+oEVX_CURS], w0
	and	w0, #EVCURS_POS_MASK, w0
	dec	w0, w0
	bra	EingVx_SetXCursor

/* -------------------- EingVx_IncXCursor -----------------------
Input:  w5=Vx.pointer

Output: w0=akt CursX pos.
	SR	Z no Change  SR=NZ Change
used;   w0:w1:w2:w3
-------------------------------------------------------------- */
EingVx_IncXCursor:
	mov	[w5+oEVX_CURS], w0
	and	w0, #EVCURS_POS_MASK, w0
	inc	w0, w0
	bra	EingVx_SetXCursor

/* -------------------- EingVx_SetXCursor -----------------------
Input:  w0=CursX pos.	w5=Vx.pointer

Output: w0=akt CursX pos.
	SR	Z no Change  SR=NZ Change
used;   w0:w1:w2:w3
-------------------------------------------------------------- */
EingVx_SetXCursor:
	mov	[w5+oEVX_DISP_FLAG], w1
	lsr	w1, #DVF_NUM_SIFT, w2
	and	#DVF_NUM_MASK, w2

	btsc	[w5], #bEVSTAT_CX_M1
	dec	w2, w2
	btsc	w2, #15
	clr	w2

	btss	w1, #bDVF_IS_1616
	dec	w2, w2
	btsc	w2, #15
	clr	w2
	btsc	w0, #15
	clr	w0
	cpsgt	w2, w0
	mov	w2, w0

	mov	[w5+oEVX_CURS], w2
	and	w2, #EVCURS_POS_MASK, w1
	mov	#~EVCURS_POS_MASK, w3
	and	w2, w3, w2
	ior	w2, w0, w2
	mov	w2, [w5+oEVX_CURS]
	cp	w0, w1
	return

/* -------------------- EingVx_Key ------------------------------
Input:  w0=Key	w5=Vx.pointer

Output: SR NZ NoHandle w0=Key
	SR Z Handle w0=0  w6=EVX_OWNER
used;   w0:w1:w2:w3:w4:w6:w7
-------------------------------------------------------------- */
EingVx_Key:
	mov	[w5], w2
	mov	#0xFF00, w3
	and	w2, w3, w2
	mov	w2, [w5]

	mov	EingVx_CursSelIdx, w2
	and	#EVCURS_SELNR_MASK, w2

	cp	w0, #KEY_SEL_TGL
	bra	z, K_CSelTgl
	btst	EingVx_CursSelIdx, #ECSI_PROP_SEL
	bra	nz, Ktg

	mov	[w5+oEVX_CURS], w3
	btst	w3, #bEVCURS_ON
	bra	z, Key_RetNoHandle

	and	#EVCURS_SELNR_MASK, w3
	cp	w2, w3
	bra	nz, Key_RetNoHandle

	cp	w0, #KEY_UP
	bra	z, K_CUp
	cp	w0, #KEY_DOWN
	bra	z, K_CDown
	cp	w0, #KEY_LEFT
	bra	z, K_CLeft
	cp	w0, #KEY_RIGHT
	bra	z, K_CRight
	return

K_CUp:
	btst	[w5], #bEVSTAT_ERROR
	bra	nz, Key_RetOk

	bset	[w5], #bEVSTAT_VAL_HANDLE	
;	mov	#(1<<bEVX_INC), w0
	mov	#(1<<bADDSUB_MM_ON), w4
	bra	k_cud
;	rcall	EingVx_IncDec
;	mov	[w5+oEVX_OWNER], w6
;	bra	Key_RetRePaint

K_CDown:
	btst	[w5], #bEVSTAT_ERROR
	bra	nz, Key_RetOk

	bset	[w5], #bEVSTAT_VAL_HANDLE
;	mov	#(1<<bEVX_DEC), w0
	mov	#(1<<bADDSUB_MM_ON)|(1<<bADDSUB_MM_SUB), w4
k_cud:
	rcall	EingVx_IncDec
	btsc	[w5], #bEVSTAT_VAL_CHANGE
	rcall	SetTastRepeat
	mov	[w5+oEVX_OWNER], w6
	bra	Key_RetRePaint

K_CLeft:
	btst	[w5], #bEVSTAT_ERROR
	bra	nz, Key_RetOk

	bclr	[w5], #bEVSTAT_XCURS_XMAX
	rcall	EingVx_IncXCursor
	mov	[w5+oEVX_OWNER], w6
	bra	nz, Key_RetRePaint
	bset	[w5], #bEVSTAT_XCURS_XMAX
	bra	Key_RetOk
K_CRight:
	btst	[w5], #bEVSTAT_ERROR
	bra	nz, Key_RetOk

	bclr	[w5], #bEVSTAT_XCURS_XMAX
	rcall	EingVx_DecXCursor
	mov	[w5+oEVX_OWNER], w6
	bra	z, Key_RetOk
	bra	Key_RetRePaint

K_CSelTgl:
	btg	EingVx_CursSelIdx, #ECSI_PROP_SEL
	mov	[w5+oEVX_OWNER], w6
	bra	Key_RetRePaint

Ktg:
	cp	w0, #KEY_UP
	bra	z, Ktg_Up
	cp	w0, #KEY_DOWN
	bra	z, Ktg_Down
;	cp	w0, #KEY_LEFT
;	bra	z, Key_RetOk
;	cp	w0, #KEY_RIGHT
;	bra	z, Key_RetOk
	return

Ktg_Up:
	sub	#1<<EVCURS_SELNR_SHL, w2
	btsc	w2, #15
	mov	EingVx_CursSelIdxMax, w2
	bra	Ktg_Set

Ktg_Down:
	add	#1<<EVCURS_SELNR_SHL, w2
	mov	EingVx_CursSelIdxMax, w0
	cp	w2, w0
	bra	le, Ktg_Set
	clr	w2
Ktg_Set:
	bset	w2, #ECSI_PROP_SEL
	mov	w2, EingVx_CursSelIdx
	mov	[w5+oEVX_OWNER], w6
	bra	Key_RetRePaint


/* w0=OnCange.pointer w5=Vx.pointer */
EingVx_Init_OnCange:

	btst	w0, #0
	bra	nz, oc_err
	mov	#0x01ff, w1
	cp	w0, w1
	bra	leu, oc_err

	mov	w0, [w5+oEVX_ON_VAL_CHANGE]
	bset	[w5], #bEVSTAT_ONCHANGE
	return
oc_err:
	bclr	[w5], #bEVSTAT_ONCHANGE
	return



.section .const, psv
txt_VxErr:	.asciz	"ERR"


txt_Einh:
		.asciz	"---"
		.asciz	"dig"
		.asciz	"V\0\0"
txt_mV:		.asciz	"mV\0"
txt_Hz:		.asciz	"Hz\0"
txt_kHz:	.asciz	"kHz"
txt_MHz:	.asciz	"MHz"
		.asciz	"%\0\0"
		.asciz	"ns\0"
		.asciz	"us\0"
		.asciz	"ms\0"
		.asciz	"s\0\0"
		.asciz	"dB\0"
txt_dBm:	.asciz	"dBm"
txt_TC:		.asciz	"\177C\0"
		.asciz	"mV/\177C"

.global txt_Einh
.global txt_mV
.global txt_dBm
.global txt_Hz
.global txt_kHz
.global txt_MHz
.global txt_TC
