
;	bEVX_DEC	= 0
;	bEVX_INC	= 1

/* ----------------------- EVX -------------------------------- */
	EVX_SIZE		= 26
	oEVX_STAT		= 0	/*  0 !!!!! */
	oEVX_RAM_DATA_ADR	= 2
	oEVX_P_TXT		= 4

	oEVX_DISP_FLAG		= 6
	oEVX_DISP_MIN		= 8
	oEVX_DISP_MAX		= 10

	oEVX_VALUE_1616		= 12
	oEVX_VALUE		= 14
	oEVX_DISP_X		= 16
	oEVX_DISP_Y		= 18
	oEVX_CURS		= 20
	oEVX_ON_VAL_CHANGE	= 22
	oEVX_OWNER		= 24


/* oEVX_STAT
 +-------------------------------+---------------+---------------+
 |                               |               |  key stat     | EVX_STAT
 +-------------------------------+---------------+---------------+
*/
	bEVSTAT_VAL_HANDLE	= 0
	bEVSTAT_VAL_CHANGE	= 1
	bEVSTAT_UV_MIN		= 2
	bEVSTAT_OV_MAX		= 3

	bEVSTAT_XCURS_XMAX	= 8
	bEVSTAT_CX_M1		= 9   /* max. Cursorpos Num-1 */
	bEVSTAT_ONLY_TXT	= 10
	bEVSTAT_OV_SET_MAX	= 12  /* OV Set Value to min/max */
	bEVSTAT_ONCHANGE	= 13
.if XR_DATA_SEG_SIZE
	bEVSTAT_REL_RAM		= 14  /* rel. Ram Adr. */
.endif
	bEVSTAT_ERROR		= 15  /* Fram Adr. Error */
/*
  15  14  13  12  11  10   9   8   7   6   5   4   3   2   1   0
 +-------------------+-------------------------------------------+
 |                   |               FRam Adr.                   | IO FRam Adr.
 +-------------------+-------------------------------------------+
*/
	EVCURS_FRAM_MASK	= 0x07FF

/* oEVX_DISP_FLAG   -->  in sys.inc
  15  14  13  12  11  10   9   8   7   6   5   4   3   2   1   0
 +---+-----------+---+-----------+-----------+---+---+---+----+--+
 |   |    Nk     |   |   Num     |           |Fon|   |32 |Byte|US|
 +---+-----------+---+-----------------------+---+---+---+----+--+
*/
/*	bDVF_IS_UNSIGN		= 0  in sys.inc  */
/*	bDVF_IS_BYTE		= 1  in sys.inc  */
/*	bDVF_IS_1616		= 2  in sys.inc  */
/*	bDVF_FONT		= 4  0=8x13  1=cs  in sys.inc  */

/* oEVX_CURS 
  15  14  13  12  11  10   9   8   7   6   5   4   3   2   1   0
 +---+---+---+---+---+-----------+-----------+---+---+---+----+--+
 |SEL| ON|TXT|   |   |   |SEL_FKT|     SELNR     |   XCURS POS   |
 +---+---+---+---+---+-----------------------+---+---+---+----+--+
*/
	EVCURS_POS_MASK		= 0x000F
	EVCURS_SELNR_MASK	= 0x00F0
	EVCURS_SELNR_SHL	= 4

	EVCURS_SELFKT_MASK	= 0x0300
	EVCURS_SELFKT_SHL	= 8
	EVCURS_SELFKT_LEFT	= 1
	EVCURS_SELFKT_LEFT64	= 2

	bEVCURS_ADD_TXT		= 13
	bEVCURS_ON		= 14
;	bEVCURS_SEL		= 15

/* --------- oEVX_ON_VAL_CHANGE -----------------------------------
	w0:w1=Value
	w2=EVX_DISP_FLAG
	w3  0=Value Change  1=open  2=close
	w6=EVX_OWNER
------------------------------------------------------------------- */
	ON_CHANGE_VALUE		= 0
	ON_CHANGE_OPEN		= 1
	ON_CHANGE_CLOSE		= 2
	ON_CHANGE_RELOAD	= 3


	TXT_dig		= 1
	TXT_V		= 2
	TXT_mV		= 3
	TXT_Hz		= 4
	TXT_kHz		= 5
	TXT_MHz		= 6
	TXT_perc	= 7
	TXT_ns		= 8
	TXT_us		= 9
	TXT_ms		= 10
	TXT_s		= 11
	TXT_dB		= 12
	TXT_dBm		= 13
	TXT_TC		= 14
	TXT_mVpTC	= 15

/* ----------------------- TabStep --------------------------------
      word 0          word 2           word 3         word  4
 +---------------+
 |   Tab size    |
 +---------------+
 +---------------+---------------+---------------+---------------+
 |     FLAG      |  DISP_FLAG    |     MIN       |      MAX      |  idx 0
 +---------------+-------------------------------+---------------+
            ...........................................
 +---------------+---------------+---------------+---------------+
 |     FLAG      |  DISP_FLAG    |     MIN       |      MAX      |  idx n
 +---------------+-------------------------------+---------------+
*/
	ETS_SIZE		= 8
	oETS_FLAG		= 0
	oETS_DISP_FLAG		= 2
	oETS_MIN		= 4
	oETS_MAX		= 6

	bETS_FLAG_INC_NO_DIV	= 4
	bETS_FLAG_DEC_NO_MUL	= 5
	bETS_FLAG_NO_CHK_CMAX	= 6  /* +INC_NO_DIV set CursX to max */

/* ----------------------- TabStepRef -----------------------------
      word 0          word 2           word 3         word  4
 +---------------+---------------+---------------+---------------+
 |  P TabStep    |  Pointer Idx  |      X        |      Y        |
 +---------------+-------------------------------+---------------+
*/
	ETSR_SIZE		= 8
	oETSR_P_ETS		= 0
	oETSR_P_IDX		= 2
	oETSR_X			= 4
	oETSR_Y			= 6

/* --------------------------- DVF lcd_param ---------------------------- */
	bDVF_DP_X10		= 11
	bDVF_DP_MX1		= 15

/* --------------------------- lcd_filter param ------------------------- */
;	VX_FILTER_LC		= 0x8000
;	bVX_FILTER_LC		= 15

