/*
 Copyright (C) 2014-2022 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "Param.inc"

.section .nbss, bss, near
I2CErrorFlag:		.space 2

.global I2CErrorFlag

.section .text
.global i2c_x_dev_handle

i2c_x_dev_handle:
	cp0	i2c2_Lock
	bra	z, NoLock

	rcall	Handle_I2C2

	mov	#I2C_FM24CL048, w0	/* i2c2_id = 0xA0/0xA2 FRAM */
	cp	i2c2_Lock
	bra	z, FM24CL048_i2c_run

	mov	#I2C_MCP3421, w0	/* i2c2_id = 0xd0  ADC 18B */
	cp	i2c2_Lock
	bra	z, MCP3421_i2c_run

	mov	#I2C_ADS112c04, w0	/* i2c2_id = 0xd0  ADC 18B */
	cp	i2c2_Lock
	bra	z, ADS112c04_i2c_run

	mov	#I2C_DAC7578, w0	/* i2c2_id = 0x90/0x94  16 * DAC 12B */
	cp	i2c2_Lock
	bra	z, DAC7578_i2c_run

	mov	#I2C_MCP47FEB, w0	/* i2c2_id = 0xC0  2* DAC 12B */
	cp	i2c2_Lock
	bra	z, MCP47FEB_i2c_run

	mov	#I2C_AD5667, w0		/* i2c2_id = 0x1E  2* DAC 12B */
	cp	i2c2_Lock
	bra	z, AD5667_i2c_run

	mov	#I2C_MCP4726, w0	/* i2c2_id = 0xC4  1* DAC 12B */
	cp	i2c2_Lock
	bra	z, MCP4726_i2c_run

.if USE_PLL_CDCE913
	mov	#I2C_CDCE913, w0
	cp	i2c2_Lock
	bra	z, CDCE913_i2c_run
.endif

.if USE_UART_I2C_BRIDGE
	mov	#I2C2_UART, w0
	cp	i2c2_Lock
	bra	z, I2C2_UART_run
.endif

	clr	i2c2_Lock	/* ?????????????? */
	return
NoLock:

	btss	ExMemFlag, #DataOk
	rcall	FM24CL048_Handle

.if USE_PLL_CDCE913
	rcall	CDCE913_Handle
.endif

	cp0	DAC7578_OutFlag
	btss	SR, #Z
	rcall	DAC7578_Handle

	cp0	MCP47FEB_OutFlag
	btss	SR, #Z
	rcall	MCP47FEB_Handle

	cp0	AD5667_OutFlag
	btss	SR, #Z
	rcall	AD5667_Handle

	cp0	MCP4726_OutFlag
	btss	SR, #Z
	rcall	MCP4726_Handle

	cp0	MCP3421_ms_count
	btsc	SR, #Z
	rcall	MCP3421_Handle

	cp0	ADS112c04_ms_count
	btsc	SR, #Z
	rcall	ADS112c04_Handle


.if USE_UART_I2C_BRIDGE
	cp0	uart_i2c2_cmd
	btss	SR, #Z
	rcall	UART_I2C_Bridge_Handle
.endif

	bra	Handle_I2C2
