/*
 Copyright (C) 2014-2022 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"

.section .text

.global Ram_GetValue
.global Ram_SetValue

/* -------------------- Ram_GetValue -----------------------------
Input:	w2=RamAdr
	w3=size 0..3 (1-4Byte)
Output: w0:w1=Value			ERROR SR set OV
used:	w0:w1:w2
------------------------------------------------------------------- */
Ram_GetValue:
	clr	w0
	clr	w1
	cp	w3, #3
	bra	gtu, ret_set_ov

	ze	[w2++], w0
	cp0	w3
	bra	z, rgv_e
	swap	w0
	mov.b	[w2++], w0
	swap	w0
	cp	w3, #1
	bra	z, rgv_e
	
	ze	[w2++], w1
	cp	w3, #2
	bra	z, rgv_e
	swap	w1
	mov.b	[w2++], w1
	swap	w1
rgv_e:
	bclr	SR, #OV
	return

/* -------------------- Ram_SetValue -----------------------------
Input:	w0:w1=Value	w2=RamAdr
	w3=size 0..3 (1-4Byte)
Output: 				ERROR SR set OV
used:	w0:w1:w2
------------------------------------------------------------------- */
Ram_SetValue:
	cp	w3, #3
	bra	gtu, ret_set_ov

	mov.b	w0, [w2++]
	cp0	w3
	bra	z, rsv_e
	swap	w0
	mov.b	w0, [w2++]
	cp	w3, #1
	bra	z, rsv_e

	mov.b	w1, [w2++]
	cp	w3, #2
	bra	z, rsv_e
	swap	w1
	mov.b	w1, [w2++]
rsv_e:
	bclr	SR, #OV
	return
