/*
 Copyright (C) 2014-2023 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"

.section .text

.global div_s32_u16_s16r

.section .text

/* ------------------------- div_s32_u16_s16r -----------------
Input:  w0:w1 = signed val  /  w2 = unsigned val
Output: w0 = signed val				Error: set SR #OV
used:   w0,w1,w2				43 Clk
------------------------------------------------------------ */

div_s32_u16_s16r:
	cp0	w2
	bra	z, lerr
	btst	w1, #15
	bra	z, div_u32r

	subr	w0, #0, w0
	subbr	w1, #0, w1
	repeat	#17
	div.ud	w0, w2
	bra	ov, ov_neg
/* Round */
	lsr	w2, w2
	addc	w2, #0, w2
	sub	w1, w2, w1
	addc	w0, #0, w0
	bra	n, ov_cp_neg
	subr	w0, #0, w0
	bclr	SR, #OV
	return

ov_cp_neg:
	mov	#0x8000, w1
	cp	w0, w1
	bra	z, max_neg
ov_neg:
	mov	#0x8000, w0
	bset	SR, #OV
	return
max_neg:
	mov	#0x8000, w0
	bclr	SR, #OV
	return

div_u32r:
	repeat	#17
	div.ud	w0, w2
	bra	ov, ov_pos
	btst	w0, #15
	bra	nz, ov_pos

/* Round */
	lsr	w2, w2
	addc	w2, #0, w2
	sub	w1, w2, w1
	addc	w0, #0, w0
	bra	ov, ov_pos
	return
ov_pos:
	mov	#0x7fff, w0
	bset	SR, #OV
	return
lerr:
	clr	w0
	bset	SR, #OV
	return
