/*
 Copyright (C) 2014-2022 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "libm.inc"

.section .text
.global f32_f48

/* ------------------------- f32_f48 ------------------------
Input:  w0:w1  ==>  w2=Fx Pointer
used:   w0:w1:w6:w7			30 Clk
------------------------------------------------------------ */

f32_f48:
;	cp0	w1
;	bra	z, f48res_0_pw2
	
	mov	w1, w7
	mov	#0x7F80, w6
	and	w7, w6, w7
	bra	z, f48res_0_pw2
	cp	w7, w6
	bra	z, f48res_0_pw2
	lsr	w7, #7, w7

	mov	#0x3F80, w6
	add	w7, w6, w7
	btsc	w1, #15
	bset	w7, #15

	sl	w1, #8, w1
	bset	w1, #15
	lsr	w0, #8, w6
	ior	w1, w6, w1
	sl	w0, #8, w0
	
	mov.d	w0, [w2]
	mov	w7, [w2+4]
	bclr	SR, #OV
	return
