/*
 Copyright (C) 2014-2022 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "libm.inc"

.section .text
.global f48_abs

/* -------------------- f48_abs ----------------------------
Input:  w4=Fx Pointer abs
Output:
used; w0:w1					13 Clk (MISC_OV 19 Clk)
------------------------------------------------------------ */

f48_abs:
.if F48_CHK_MISC_OV
	mov	[w4+4], w0
	bclr	w0, #15
	mov	w0, [w4+4]
	bclr	SR, #OV
	mov	#0x7FFF, w1		; chk exp.
	and	w0, w1, w0		; exp.
	cp	w0, w1			; te op error
	btsc	SR, #Z
	bset	SR, #OV
	return
.else
	add	w4, #4, w0
	bclr	SR, #OV
	bclr	[w0], #15
	return
.endif
