/*
 Copyright (C) 2014-2020 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "libm.inc"

.section .text
.global f48_add_exp_w2
.global f48_add_exp_w3
.global f48_add_exp_w4

/* ------------------------- f48_add_exp_w2 -------------------
Input:  w0 = signed val + Exp. ==>  w(2,3,4)=Fx Pointer
Output: 				Error: set SR #OV
used;   w0:w1:w6:w7			22 Clk
		f48_add_exp_w3		26 Clk
		f48_add_exp_w4		26 Clk
------------------------------------------------------------ */

f48_add_exp_w2:
	mov	w2, w6
f48_add_exp_XX:
	mov	#0x7FFF, w1
	mov	[w6+4], w7
	and	w7, w1, w1
	add	w1, w0, w1

.if F48_CHK_OVERFLOW
	btst	w1, #15
	bra	nz, res_pw6_inf
	inc	w1, w0
	bra	n, res_pw6_inf_pos
.endif
	btsc	w7, #15
	bset	w1, #15
	mov	w1, [w6+4]
	return
.if F48_CHK_OVERFLOW
res_pw6_inf:
	btst	w1, #14
	bra	z, res_pw6_inf_pos
	mov	#0xFFFF, w1
	mov	w1, [w6+4]
	mov	#0x0000, w0
	mov	#0x8000, w1
	mov.d	w0, [w6]
	bset	SR, #OV
	return
res_pw6_inf_pos:
	mov	#0x7FFF, w1
	mov	w1, [w6+4]
	mov	#0x0000, w0
	mov	#0x8000, w1
	mov.d	w0, [w6]
	bset	SR, #OV
	return
.endif

f48_add_exp_w4:
	mov	w4, w6
	bra	f48_add_exp_XX

f48_add_exp_w3:
	mov	w3, w6
	bra	f48_add_exp_XX
