/*
 Copyright (C) 2014-2023 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "libm.inc"

.section .text
.global f48_copy_sign

/* -------------------- f48_copy_sign ----------------------
Input:  w2=Fx Pointer  sign ->  w4=Fx Pointer
Output:
used; w5:w6				20 Clk (MISC_OV 29 Clk)
------------------------------------------------------------ */

f48_copy_sign:
	mov	[w4+2], w0
	btst	w0, #15
	bra	z, f48return_clr_OV
#if F48_CHK_MISC_OV
	mov	[w2+4], w6
	mov	[w4+4], w5
	sl	w5, w5
	rlc	w6, w6
	rrc	w5, w5
	mov	w5, [w4+4]
	bra	f48res_ChkExp_OV_w5
#else
	bclr	SR, #OV
	mov	[w2+4], w6
	mov	[w4+4], w5
	sl	w5, w5
	rlc	w6, w6
	rrc	w5, w5
	mov	w5, [w4+4]
	return
#endif
