/*
 Copyright (C) 2014-2022 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"

.section .text
.global f48_cp

/* -------------------- f48_cp -----------------------------
Input:  w2=Fx Pointer  <==>  w3=Fx Pointer  ==>  SR
Output:
used; w0:w1:w5:w6:w7			22..31 Clk
------------------------------------------------------------ */

f48_cp:
	mov	[w2+4], w0
	mov	[w3+4], w5

	xor	w0, w5, w6
	bra	n, f48_cp_sig

	mov	#0x7FFF, w6
	and	w0, w6, w0
	and	w5, w6, w1


	btst	w5, #15
	bra	nz, f48_cp_neg

	cp	w0, w1		; test exp1 <> exp2
	btss	SR, #Z
	return

	mov.d	[w2], w0
	cp	w0, [w3++]
	cpb	w1, [w3--]
	return

f48_cp_neg:
	cp	w1, w0		; test exp1 <> exp2
	btss	SR, #Z
	return

	mov.d	[w3], w0
	cp	w0, [w2++]
	cpb	w1, [w2--]
	return

f48_cp_sig:
	asr	w0, #15, w0
	asr	w5, #15, w5
	cp	w0, w5
	return
