/*
 Copyright (C) 2014-2022 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "libm.inc"

.section .text
.global f48_f32

/* ------------------------- f48_f32 ------------------------
Input:  w4=Fx Pointer ==> w0:w1
Output: 			Error SR set #OV
used:   w0:w1:w5:w6:w7			37 Clk
------------------------------------------------------------ */

f48_f32:
	mov.d	[w4], w0
	cp0	w1
	bra	z, f48i32_0

	mov	[w4+4], w7
	mov	w7, w5
	bclr	w5, #15
	mov	#0x3FFF, w6
	sub	w5, w6, w5
	mov	#0x007F, w6
	add	w5, w6, w5
	bra	z, fov
	cp	w5, #0x00FF
	bra	z, fov
	
	mov	#0xFF00, w6
	and	w5, w6, w6
	bra	nz, fov

	sl	w5, #7, w5
	lsr	w0, #8, w0
	sl	w1, #8, w6
	ior	w0, w6, w0
	lsr	w1, #8, w1
	bclr	w1, #7
	ior	w1, w5, w1
	btsc	w7, #15
	bset	w1, #15
	bclr	SR, #OV
	return
fov:
	mul.uu	w0, #0, w0
	bset	SR, #OV
	return
