/*
 Copyright (C) 2014-2020 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "libm.inc"

.section .text
.global f48_i16r

/* ------------------------- f48_i16r (round) -----------------
Input:  w4 = Fx Pointer
Output: w0 signed val			Error: set SR #OV
used:   w0:w1:w5:w6:w7			30 Clk
------------------------------------------------------------ */

f48_i16r:
	mov	[w4+2], w0
	cp0	w0
	bra	z, f48i16_0

	mov	[w4+4], w7
	mov	w7, w5
	bclr	w5, #15
	mov	#0x400e, w6
	sub	w6, w5, w6
	bra	le, f48i16_max


	cp	w6, #16
	bra	gt, f48i16_0
	bra	z, f48i16r_1

	subr	w6, #16, w5
	sl	w0, w5, w1
	lsr	w0, w6, w0
	rlc	w1, w1
	addc	w0, #0, w0
	bra	n, f48i16r_8000

	btsc	w7, #15
	subr    w0, #0, w0
	return

f48i16r_8000:
	btsc	w7, #15
	dec	w6, w6
	bra	f48i16_max

f48i16r_1:
	mov	#1, w0
	btsc	w7, #15
	subr    w0, #0, w0
	return
