/*
 Copyright (C) 2014-2020 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "libm.inc"

.section .text
.global f48_i32
.global f48_i1616

/* ------------------------- f48_i32 --------------------------
Input:  w4=Fx Pointer
Output: w0:w1 signed val		Error: set SR #OV
used:   w0:w1:w5:w6:w7			34 Clk
------------------------------------------------------------ */
f48_i32:
	mov	#0x401e, w6
f48_iXX:
	mov.d	[w4], w0
	ior	w0, w1, w7
	bra	z, f48i32_0

	mov	[w4+4], w7
	mov	w7, w5
	bclr	w5, #15
	sub	w6, w5, w6
	bra	le, f48i32_max
	cp	w6, #31
	bra	gt, f48i32_0
.if 1
	cp	w6, #16
	bra	ge, f48i32_sh
	subr	w6, #16, w5
	sl	w1, w5, w5
	lsr	w0, w6, w0
	lsr	w1, w6, w1
	ior	w0, w5, w0
	btss	w7, #15
	return
	subr    w0, #0, w0
	subbr   w1, #0, w1
;	bclr	SR, #OV
	return

f48i32_sh:
	and	w6, #0x0f, w6
	lsr	w1, w6, w0
	clr	w1
	btss	w7, #15
	return
	subr    w0, #0, w0
	subbr   w1, #0, w1
;	bclr	SR, #OV
	return
.else
	cp	w6, #16
	bra	lt, f48i32_sh
	mov	w1, w0
	clr	w1
f48i32_sh:
	and	w6, #0x0f, w6
	bra	z, f48i32_tn
	subr	w6, #16, w5
	sl	w1, w5, w5
	lsr	w0, w6, w0
	lsr	w1, w6, w1
	ior	w0, w5, w0
f48i32_tn:
	btss	w7, #15
	return
	subr    w0, #0, w0
	subbr   w1, #0, w1
;	bclr	SR, #OV
	return
.endif

f48_i1616:
	mov	#0x400e, w6
	bra	f48_iXX
