/*
 Copyright (C) 2014-2020 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "libm.inc"

.section .text
.global f48_i32r


/* ------------------------- f48_i32r (round) -----------------
Input:  w4=Fx Pointer
Output: w0:w1 signed val		Error: set SR #OV
used:   w0:w1:w5:w6:w7			43 Clk
------------------------------------------------------------ */
f48_i32r:
	mov.d	[w4], w0
	ior	w0, w1, w6
	bra	z, f48res_0_pw4

	mov	[w4+4], w7
	mov	w7, w5
	bclr	w5, #15
	mov	#0x401e, w6
	sub	w6, w5, w6
	bra	le, f48i32_max

	cp	w6, #32
	bra	gt, f48i32_0
	bra	z, f48i32r_1
.if 1
	cp	w6, #16
	bra	ge, f48i32r_sh

	subr	w6, #16, w7
	sl	w0, w7, w5
	sl	w1, w7, w7
	lsr	w0, w6, w0
	lsr	w1, w6, w1
	ior	w0, w7, w0
	rlc	w5, w5
	addc	w0, #0, w0
	addc	w1, #0, w1
	bra	n, f48i32r_8000

	mov	[w4+4], w7
	btss	w7, #15
	return
	subr    w0, #0, w0
	subbr   w1, #0, w1
	return


f48i32r_sh:
	mov	w0, w5
	and	w6, #0x0f, w6
	bra	z, f48i32r_tn
	subr	w6, #16, w7
	sl	w1, w7, w5
	lsr	w1, w6, w1
f48i32r_tn:
	sl	w5, w5
	addc	w1, #0, w0
	mov	#0, w1
	addc	w1, #0, w1

	mov	[w4+4], w7
	btss	w7, #15
	return
	subr    w0, #0, w0
	subbr   w1, #0, w1
	return

.else
	clr	w5
	cp	w6, #16
	bra	lt, f48i32r_sh
	mov	w0, w5
	mov	w1, w0
	clr	w1
f48i32r_sh:
	and	w6, #0x0f, w6
	bra	z, f48i32r_tn
	subr	w6, #16, w7
	sl	w0, w7, w5
	sl	w1, w7, w7
	lsr	w0, w6, w0
	lsr	w1, w6, w1
	ior	w0, w7, w0
f48i32r_tn:
	rlc	w5, w5
	addc	w0, #0, w0
	addc	w1, #0, w1
	bra	n, f48i32r_8000

	mov	[w4+4], w7
	btss	w7, #15
	return
	subr    w0, #0, w0
	subbr   w1, #0, w1
;f48i32r_00:
	return
.endif
f48i32r_8000:
	mov	[w4+4], w7
	btsc	w7, #15
	dec	w6, w6
	bra	f48i32_max

f48i32r_1:
	mov	#1, w0
	clr	w1
	btss	w7, #15
	return
	mov	#0xFFFF, w0
	mov	w0, w1
	return
