/*
 Copyright (C) 2014-2022 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "libm.inc"

.section .text
.global f48_lim

/* ------------------------- f48_lim ---------------------
Input:  w2=Fx Pointer max. w3=Fx Pointer min.  w4=Fx Pointer to min/max
Output: SR Z=1 nochange  SR Z=0 change  C=1 max change
used:   w0:w1:w5:w6:w7			42..78 Clk
------------------------------------------------------------ */

f48_lim:
	rcall	f48_cp_w2w4
	bra	lt, fl_max
	rcall	f48_cp_w3w4
	bra	gt, fl_min
	bset	SR, #Z
	return
fl_max:
	mov.d	[w2], w0
	mov.d	w0, [w4]
	mov	[w2+4], w5
	mov	w5, [w4+4]
#if F48_CHK_MISC_OV
	rcall	f48res_ChkExp_OV_w5
#endif
	bclr	SR, #Z
	bset	SR, #C
	return
fl_min:
	mov.d	[w3], w0
	mov.d	w0, [w4]
	mov	[w3+4], w5
	mov	w5, [w4+4]
#if F48_CHK_MISC_OV
	rcall	f48res_ChkExp_OV_w5
#endif
	bclr	SR, #Z
	bclr	SR, #C
	return
