
.include "sys.inc"
.include "libm.inc"

.section .text
.global f48_log10_17

/* -------------------- f48_log10_17   only 17Bit -------------
Input:  w2=Fx Pointer  log10(pw2)  ==>  w4=Fx Pointer
Output: 			Error SR set #OV
used:   w0:w1:w5:w6:w7		ca. 335 Clk
------------------------------------------------------------ */

f48_log10_17:
	push.d	w8
	push.d	w2
	rcall	f48_log2_17_base
	bra	ov, f48log10_end

	ior	w0, w1, w3
	bra	z, f48log10_0

	btst	w1, #15			; test negative
	bra	z, f48log10_pos
	bset    w5, #15			; set negative
	subr    w0, #0, w0
	subbr   w1, #0, w1
f48log10_pos:
	ff1l    w1, w3
	bra     nc, f48log10_sh32	; jp w1 > 0
	sub	#16, w5			; exp - 16
	exch	w0, w1
	ff1l    w1, w3
f48log10_sh32:
	dec	w3, w3
	bra	z, f48_log10_sh_end	; jp shift 0
	sub	w5, w3, w5		; exp - shift
	subr	w3, #16, w2
	lsr	w0, w2, w2
	sl	w0, w3, w0
	sl	w1, w3, w1
	ior	w1, w2, w1
f48_log10_sh_end:

;      wl*kl
;   wh*kl
;   wl*kh
;wh*kh


/* 0x100000000 / 3.321928094887 (log2(10.0)) --> 0x4d104d42 */

;	mov	#0x5612, w2	/* 0x4d42 + round -> 0x5612 */
	mov	#0x4d42, w2	/* 0x4d42 + round -> 0x5612 */
	mul.uu	w2, w0, w8	/* kL * wL */
	mul.uu	w2, w1, w2	/* kL * wH */
	sl	w8, w8
	addc	w2, w9, w2
	addc	w3, #0, w3
	clr	w8
	addc	w8, #0, w8

	mov	#0x4D10, w6
	mul.uu	w6, w0, w6	/* kH * wL */
	add	w2, w6, w2
	addc	w3, w7, w3
	addc	w8, #0, w8

	mov	#0x4D10, w0	/* kH * wH */
	mul.uu	w0, w1, w0
	add	w0, w3, w0
	addc	w1, w8, w1

	sl	w2, w2
	rlc	w0, w0
	rlc	w1, w1
	dec	w5, w5
	btst	w1, #15
	bra	nz, f48log10_ssh1
	sl	w2, w2
	rlc	w0, w0
	rlc	w1, w1
	dec	w5, w5
f48log10_ssh1:
	mov.d	w0, [w4];
	mov	w5, [w4+4];

f48log10_end:
	pop.d	w2
	pop.d	w8
	return

f48log10_0:
	mul.uu	w0, #0, w0
	mov.d	w0, [w4]
	mov	w0, [w4+4]
	pop.d	w2
	pop.d	w8
	return
