/*
 Copyright (C) 2014-2022 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "libm.inc"

/*
  +-+-------------+  +---------------------+
  |S|  15Bit exp  |  |        32Bit        |
  +-+-------------+  +---------------------+


inf	0x7FFF 0x80000000	res f2i -> 2147483647
-inf	0xFFFF 0x80000000	res f2i -> -2147483648
nan	0x7FFF 0x00000000	res f2i -> 0
nan	0xFFFF 0x00000000	res f2i -> 0

*/

.section .text

.global f48res_0_pw2
.global f48res_0_pw3
.global f48res_0_pw4
.global f48return_clr_OV
.global f48res_NAN_pw4
.global f48res_INF_neg_pw4
.global f48res_INF_pos_pw4
.global f48res_INF_pw4
.global f48res_ChkExp_OV_pw4
.global f48res_ChkExp_OV_w5

f48res_0_pw2:
	mul.uu	w0, #0, w0
	mov.d	w0, [w2]
	mov	w0, [w2+4]
	bclr	SR, #OV
	return

f48res_0_pw3:
	mul.uu	w0, #0, w0
	mov.d	w0, [w3]
	mov	w0, [w3+4]
	bclr	SR, #OV
	return


f48res_0_pw4:
	mul.uu	w0, #0, w0
	mov.d	w0, [w4]
	mov	w0, [w4+4]
f48return_clr_OV:
	bclr	SR, #OV
	return


f48res_NAN_pw4:
	mov	#0x7FFF, w5
	mul.uu	w0, #0, w0
	mov.d	w0, [w4]
	mov	w5, [w4+4]
	bset	SR, #OV
	return


f48res_INF_neg_pw4:
	mov	#0xFFFF, w5
	mov	#0x0000, w0
	mov	#0x8000, w1
	mov.d	w0, [w4]
	mov	w5, [w4+4]
	bset	SR, #OV
	return

f48res_INF_pos_pw4:
	mov	#0x7FFF, w5
	mov	#0x0000, w0
	mov	#0x8000, w1
	mov.d	w0, [w4]
	mov	w5, [w4+4]
	bset	SR, #OV
	return


f48res_INF_pw4:
	btst	w7, #15
	bra	z, f48res_INF_pos_pw4
	bra	f48res_INF_neg_pw4


f48res_ChkExp_OV_pw4:
	mov	[w4+4], w5
f48res_ChkExp_OV_w5:
	bclr	SR, #OV
	mov	#0x7FFF, w6		; chk exp.
	and	w5, w6, w5		; exp.

	cp	w5, w6			; te op error
	btsc	SR, #Z
	bset	SR, #OV
	return


