/*
 Copyright (C) 2014-2023 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "libm.inc"

.section .text
.global f48_neg

/* -------------------- f48_neg ----------------------------
Input:  w4=Fx Pointer neg
Output:
used; w0					16 Clk (MISC_OV 22 Clk)
------------------------------------------------------------ */

f48_neg:
	mov	[w4+2], w0
	btst	w0, #15
	bra	z, f48return_clr_OV
.if F48_CHK_MISC_OV
	mov	[w4+4], w0
	btg	w0, #15
	mov	w0, [w4+4]
	bclr	SR, #OV
	mov	#0x7FFF, w1		; chk exp.
	and	w0, w1, w0		; exp.
	cp	w0, w1			; te op error
	btsc	SR, #Z
	bset	SR, #OV
	return
.else
	add	w4, #4, w0
	bclr	SR, #OV
	btg	[w0], #15
	return
.endif
