/*
 Copyright (C) 2014-2023 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "libm.inc"

.section .text
.global f48_neg_mov

/* -------------------- f48_neg ----------------------------
Input:  w2=Fx Pointer  --> neg -->  w4=Fx Pointer
Output:
used; w0:w1					20 Clk (MISC_OV 25 Clk)
------------------------------------------------------------ */

f48_neg_mov:
	mov.d	[w2], w0
	btst	w1, #15
	bra	z, f48res_0_pw4
	mov.d	w0, [w4]
	mov	[w2+4], w0
	btg	w0, #15
	mov	w0, [w4+4]
	bclr	SR, #OV
.if F48_CHK_MISC_OV
	mov	#0x7FFF, w1		; chk exp.
	and	w0, w1, w0		; exp.
	cp	w0, w1			; te op error
	btsc	SR, #Z
	bset	SR, #OV
.endif
	return
