/*
 Copyright (C) 2014-2023 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "libm.inc"

.section .text
.global f48_shift

/* ------------------------- f48_shift ---------------------
Input:  w0=Shift w2=Fx Pointer --> shift w0 --> w4=Fx Pointer
Output: result none
   used w0:w1:w2:w3:w4:w5:w7			28 Clk
------------------------------------------------------------ */

f48_shift:
	mov	[w2+2], w1
	btst	w1, #15
	bra	z, f48res_0_pw4

	mov	[w2+4], w7
	mov	#0x7FFF, w1
	and	w7, w1, w5
	add	w5, w0, w5

.if F48_CHK_OVERFLOW
	btst	w5, #15
	bra	nz, f48res_NAN_pw4
	inc	w5, w0
	bra	n, chk_inf
.endif
	mov.d	[w2], w0
	mov.d	w0, [w4]

	btsc	w7, #15
	bset	w5, #15
	mov	w5, [w4+4]
	return
chk_inf:
	btst	w1, #14
	bra	z, f48res_NAN_pw4
	bra	f48res_INF_neg_pw4
