/*
 Copyright (C) 2014-2020 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "libm.inc"

.section .text
.global f48_u16

/* ------------------------- f48_u16 ------------------------
Input:  w4 = Fx Pointer
Output: w0 signed val			Error: set SR #OV
used:   w0:w5:w6			21 Clk
------------------------------------------------------------ */

f48_u16:
	mov	[w4+2], w0
	cp0	w0
	bra	z, f48u16_00

	mov	[w4+4], w5
	btst	w5, #15
	bra	nz, f48u16_neg

	mov	#0x400e, w6
	sub	w6, w5, w6
	bra	lt, f48u16_max
;	bra	z, f48u16_00
;	cp	w6, #15
;	bra	gt, f48i16_0
	lsr	w0, w6, w0
f48u16_00:
	bclr	SR, #OV
	return

f48u16_max:
	mov	#0xFFFF, w0
	bset	SR, #OV
	return

f48u16_neg:
	mov	#0x0000, w0
	bset	SR, #OV
	return

