/*
 Copyright (C) 2014-2022 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "libm.inc"

.section .text
.global f48_u32
.global f48_u1616

/* ------------------------- f48_u32 --------------------------
Input:  w4=Fx Pointer
Output: w0:w1 signed val		Error: set SR #OV
used:   w0:w1:w5:w6			35 Clk
			f48_u1616	39 Clk
------------------------------------------------------------ */
f48_u32:
	mov	#0x401e, w6
f48_uXX:
	mov.d	[w4], w0
	ior	w0, w1, w5
	bra	z, f48i32_0

	mov	[w4+4], w5
	btst	w5, #15
	bra	nz, f48u32_neg

	sub	w6, w5, w6
	bra	lt, f48u32_max

	cp	w6, #31
	bra	gt, f48i32_0

	cp	w6, #16
	bra	lt, f48u32_sh
	mov	w1, w0
	clr	w1
f48u32_sh:
	and	w6, #0x0f, w6
	bra	z, f48u32_00
	subr	w6, #16, w5
	sl	w1, w5, w5
	lsr	w0, w6, w0
	lsr	w1, w6, w1
	ior	w0, w5, w0
f48u32_00:
	bclr	SR, #OV
	return

/*
f48u32_max:
	mov	#0xFFFF, w0
	mov	#0xFFFF, w1
	bset	SR, #OV
	return

f48u32_neg:
	mul.uu	w0, #0, w0
	bset	SR, #OV
	return
*/

f48_u1616:
	mov	#0x400e, w6
	bra	f48_uXX
