/*
 Copyright (C) 2014-2022 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "libm.inc"

.section .text
.global f48_u32r
.global f48_u1616r

/* ------------------------- f48_u32r -------------------------
Input:  w4=Fx Pointer
Output: w0:w1 signed val		Error: set SR #OV
used:   w0:w1:w5:w6:w7			39 Clk
			f48_u1616r	49 Clk
------------------------------------------------------------ */
f48_u32r:
	mov	#0x401e, w6
f48_uXXr:
	mov.d	[w4], w0
	ior	w0, w1, w5
	bra	z, f48i32_0

	mov	[w4+4], w5
	btst	w5, #15
	bra	nz, f48u32_neg

	sub	w6, w5, w6
	bra	lt, f48u32_max
	bra	z, f48u32r_sh0

	cp	w6, #32
	bra	gt, f48i32_0
	bra	z, f48u32r_1

	cp	w6, #16
	bra	ge, f48u32r_sh
	subr	w6, #16, w5
	sl	w0, w5, w7
	sl	w1, w5, w5
	lsr	w0, w6, w0
	lsr	w1, w6, w1
	ior	w0, w5, w0
	sl	w7, w7
	addc	w0, #0, w0
	addc	w1, #0, w1
	bclr	SR, #OV
f48u32r_sh0:
	return

f48u32r_sh:
	mov	w0, w5
	and	w6, #0x0f, w6
	bra	z, f48u32r_tn
	subr	w6, #16, w7
	sl	w1, w7, w5
	lsr	w1, w6, w1
f48u32r_tn:
	sl	w5, w5
	addc	w1, #0, w0
	clr	w1
	addc	w1, #0, w1
	return

f48u32r_1:
	mov	#1, w0
	clr	w1
	return

f48_u1616r:
	mov	#0x400e, w6
	bra	f48_uXXr
