/*
 Copyright (C) 2014-2020 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "libm.inc"

.section .text
.global i16_f48_w3

/* ------------------------- i16_f48 --------------------------
Input:  w0 = signed val  ==>  w3=Fx Pointer
Output: result none
used:   w0:w1:w5:w6			24 Clk
------------------------------------------------------------ */

i16_f48_w3:
	mov	#0x400e, w5		; set exp

	btst	w0, #15			; test negative
	bra	z, i16f48_pos
	bset    w5, #15			; set negative
	subr    w0, #0, w0
i16f48_pos:
	ff1l    w0, w6
	bra	c, f48res_0_pw3		; jp res 0
	dec	w6, w6
	sub	w5, w6, w5		; exp - shift
	sl	w0, w6, w0
	clr	[w3]
	mov	w0, [w3+2]
	mov	w5, [w3+4]
	return
