/*
 Copyright (C) 2014-2020 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "libm.inc"

.section .text
.global i32_f48_w3
.global i1616_f48_w3

/* ------------------------- i32_f48 --------------------------
Input:  w0:w1 = signed val  ==>  w3=Fx Pointer
Output: result none
used:   w0:w1:w5:w6:w7			30 Clk
		i1616_f48		34 Clk
------------------------------------------------------------ */

i32_f48_w3:
	mov	#0x401e, w5		; set exp
iXX_f48_w3:
	btst	w1, #15			; test negative
	bra	z, i32f48_pos
	bset    w5, #15			; set negative
	subr    w0, #0, w0
	subbr   w1, #0, w1
i32f48_pos:
	ff1l    w1, w6
	bra	c, i32f48_16
	dec	w6, w6
;	bra	z, i32f48_no_sh		; jp val 0
	sub	w5, w6, w5		; exp - shift
	subr	w6, #16, w7
	lsr	w0, w7, w7
	sl	w0, w6, w0
	sl	w1, w6, w1
	ior	w1, w7, w1
;i32f48_no_sh:
	mov.d	w0, [w3];
	mov	w5, [w3+4];
	return

i32f48_16:
	ff1l    w0, w6
	bra	c, f48res_0_pw3		; jp val 0
	dec	w6, w6
	sub	w5, #16, w5		; exp - 16
	sub	w5, w6, w5		; exp - shift
	sl	w0, w6, w0
	clr	[w3]
	mov	w0, [w3+2]
	mov	w5, [w3+4]
	return

i1616_f48_w3:
	mov	#0x400e, w5		; set exp
	bra	iXX_f48_w3
