/*
 Copyright (C) 2014-2022 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"

.section .text

.global mul32su

.section .text

/* ------------------------- mul32su --------------------------
Input:  w0:w1 = signed val  *  w2:w3 = unsigned val
Output: w0:w1:w2:w3 = signed val
used:   w0:w1:w2:w3:w4:w5:w6:w7				31 Clk
------------------------------------------------------------ */
mul32su:
	push.d	w8
	mov.d	w0, w4
	mov.d	w2, w6
	mul.uu	w0, w2, w0
	mul.su	w5, w7, w2

	mul.uu	w4, w7, w8
	add	w1, w8, w1
	addc	w2, w9, w2
	addc	w3, #0, w3
	addc	w4, #0, w4

	mul.su	w5, w6, w8
	add	w1, w8, w1
	addc	w2, w9, w2
	asr	w9, #15, w9
	addc	w3, w9, w3
	addc	w4, w9, w4

	pop.d	w8
	return

