/*
 Copyright (C) 2014-2020 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "libm.inc"

.section .text
.global u16_f48_w3

/* ------------------------- u16_f48 --------------------------
Input:  w0 = unsigned val  ==>  w3=Fx Pointer
Output: result none
used:   w0:w1:w5:w6			20 Clk
------------------------------------------------------------ */

u16_f48_w3:
	ff1l    w0, w6
	bra	c, f48res_0_pw3
	mov	#0x400e, w5		; set exp
	dec	w6, w6
	bra	z, u16f48_no_sh		; jp shift 0
	sub	w5, w6, w5		; exp - shift
	sl	w0, w6, w0
u16f48_no_sh:
	clr	[w3]
	mov	w0, [w3+2]
	mov	w5, [w3+4]
	return

