/*
 Copyright (C) 2014-2020 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "libm.inc"

.section .text
.global u32_f48_w3
.global u1616_f48_w3

/* ------------------------- u32_f48 --------------------------
Input:  w0:w1 = unsigned val  ==>  w3=Fx Pointer
Output: result none
used:   w0:w1:w5:w6:w7			25 Clk
		u1616_f48		29 Clk
------------------------------------------------------------ */

u32_f48_w3:
	mov	#0x401e, w5		; set exp
uXX_f48_w3:
	ff1l    w1, w6
	bra	c, i32f48_16
	dec	w6, w6
	bra	z, i32f48_no_sh		; jp val 0
	sub	w5, w6, w5		; exp - shift
	subr	w6, #16, w7
	lsr	w0, w7, w7
	sl	w0, w6, w0
	sl	w1, w6, w1
	ior	w1, w7, w1
i32f48_no_sh:
	mov.d	w0, [w3];
	mov	w5, [w3+4];
	return

i32f48_16:
	ff1l    w0, w6
	bra	c, f48res_0_pw3		; jp val 0
	dec	w6, w6
	sub	w5, #16, w5		; exp - 16
	sub	w5, w6, w5		; exp - shift
	sl	w0, w6, w0
	clr	[w3]
	mov	w0, [w3+2]
	mov	w5, [w3+4]
	return

u1616_f48_w3:
	mov	#0x400e, w5		; set exp
	bra	uXX_f48_w3
