/*
 Copyright (C) 2014-2022 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "main.inc"

.section .nbss, bss, near
GenFreq:		.space 6

.global GenFreq

.section .text
;.global SetFreq
.global MathFreq
.global SetUpFreq

/* w0:w1 Ferq */
;SetFreq:
;	mov	w0, GenFreq
;	mov	w1, GenFreq+2
;	mov	w2, GenFreq+4	; fq / div
set_freq:
	bclr	GenLongTimeFlag, #bGLT_ON
	cp	w2, #1
	bra	gt, supf_oc_gen
; if (GenFreq < 8000) goto supf_oc_gen;
	cp0	w1
	bra	nz, supf_pll_gen
	mov	#8000, w3
	cp	w0, w3
	bra	ltu, supf_oc_gen
supf_pll_gen:
	rcall	pll_on
	mov	GenFreq, w0
	mov	GenFreq+2, w1

	mov	CDCE913_fout, w2
	mov	CDCE913_fout+2, w3
	cp	w0, w2
	cpb	w1, w3
	bra	z, supf_fok

	mov	w0, CDCE913_fout
	mov	w1, CDCE913_fout+2
	rcall	calc_CDCE913_8MHz_fout
supf_fok:
	rcall	SetGenPllSym
	btst	CpuFreqStat, #bCPU_FQ_PULS_ANL
	bra	z, supf_sq
	btsc	PA_OutFlag, #bPAOF_SQ_P
;	SQUARE_CLR
	bclr	SQUARE_PORT, #SQUARE_BIT
	btss	PA_OutFlag, #bPAOF_SQ_P
supf_sq:
;	SQUARE_SET
	bset	SQUARE_PORT, #SQUARE_BIT
	return

supf_oc_gen:
	rcall	pll_off
	rcall	SetGenPllSym
	mov	GenFreq, w0
	mov	GenFreq+2, w1
	mov	GenFreq+4, w2	; fq / div
	rcall	OC1_SetFreq
	rcall	OC1_PinEnabel

	return

MathFreq:
	mov	GenFreq, w0
	mov	GenFreq+2, w1
	mov	GenFreq+4, w2
	bra	set_freq

SetUpFreq:

	btst	PA_OutFlag, #bPAOF_DC
	bra	nz, sug_dc

	rcall	GetEingCp_Freq
	mov	w0, GenFreq
	mov	w1, GenFreq+2
	mov	w2, GenFreq+4	; fq / div
	rcall	MathFreq
;	GV_ON
	bset	GV_PORT, #GV_BIT
	rcall	SetAmplDacAndRelais
	return

sug_dc:
	btst	TestFlags, #TF_DC_SQ_ON
	bra	nz, sug_sq_dc
.if USE_PLL_CDCE913
	rcall	pll_off
	rcall	SetGenPllSym
.endif
	rcall	OC1_PinDisabel

	bclr	GenLongTimeFlag, #bGLT_ON

	btss	TestFlags, #TF_DC_GEN_ON
;	GV_OFF
	bclr	GV_PORT, #GV_BIT

	btsc	TestFlags, #TF_DC_GEN_ON
	bset	GenLongTimeFlag, #bGLT_ON

	bset	SQUARE_PORT, #SQUARE_BIT
	rcall	SetAmplDacAndRelais
	return

sug_sq_dc:
;	GV_OFF
	bclr	GV_PORT, #GV_BIT
;	rcall	FreqSetUp
	rcall	GetEingCp_Freq
;	rcall	SetFreq
	mov	w0, GenFreq
	mov	w1, GenFreq+2
	mov	w2, GenFreq+4	; fq / div
	rcall	MathFreq
;	SQUARE_SET
	bset	SQUARE_PORT, #SQUARE_BIT
	rcall	SetAmplDacAndRelais
	return
