/*
 Copyright (C) 2014-2022 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "main.inc"
.include "math/libm.inc"

.section .nbss, bss, near

SettingFlags:		.space 2
;fZ_mul:			.space F48_SIZE

.global SettingFlags
;.global fZ_mul

/* ______________________________________________________________________ */
.section .text

;.global SetHighZ
.global SetTDR_DC

/*
SetHighZ:
	btst	SettingFlags, #bSF_HIGHZ
	bra	nz, shz_on
	mov	#0x0000, w0
	mov	#0x8000, w1
	mov	#0x4000, w2	; 2.0 == 50 Ohm
	bra	shz
shz_on:
	mov	#0x0000, w0
	mov	#0x8000, w1
	mov	#0x3fff, w2	; 1.0 == HighZ
shz:
	mov	w0, fZ_mul
	mov	w1, fZ_mul+2
	mov	w2, fZ_mul+4
	return
*/

SetTDR_DC:

	btsc	SettingFlags, #bSF_TDR_DC
	bset	TDR_DC_PORT, #TDR_DC_BIT

	btss	SettingFlags, #bSF_TDR_DC
	bclr	TDR_DC_PORT, #TDR_DC_BIT

	return
