/*
 Copyright (C) 2014-2022 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

.include "sys.inc"
.include "main.inc"
.include "lib/Analog.inc"
.include "lib/eingVx.inc"
.include "lcd_flags.inc"

.section .nbss, bss, near

/* ______________________________________________________________________ */
TestFlags:		.space 2
;last_tf:		.space 2

.global TestFlags

/* ______________________________________________________________________ */
.section .text

.global OnChangeTestFlagMod
.global OnChangeTestFlagDc
.global OnChangeTestFlagDcFq
.global OnChangeTestFlagFan
.global OnChangeTestFlagPow

/* -------------------- OnChangeTestMod --------------------------
OnCange(w0=Value, w1=Value shift, w2=Orig Value, w3=Stat)
------------------------------------------------------------------- */
OnChangeTestFlagMod:
	cp	w3, #ON_CHANGE_CLOSE
	bra	z, octm_close
	return

octm_close:
	cp	w1, w2
	btsc	SR, #Z
	return

	btst	w1, #bTF_POW
	bra	nz, octm_close_end
	btst	w2, #bTF_POW
	bra	z, octm_close_end

	bset	OP1_ON_PORT, #OP1_ON_BIT
	bset	OP_OFFS_PORT, #OP_OFFS_BIT

;	bset	MathFlags, #bMF_FREQ
	bset	MathFlags, #bMF_AMPL
	rcall	SetUpFreq
octm_close_end:
	return

/* -------------------- OnChangeTestKatt --------------------------
OnCange(w0=Value, w1=Value shift, w2=Orig Value, w3=Stat)
------------------------------------------------------------------- */
OnChangeTestFlagDc:
	cp	w3, #ON_CHANGE_VALUE
	bra	z, octf_change
	cp	w3, #ON_CHANGE_OPEN
	bra	z, octf_dc_open
	return

octf_dc_open:
	btss	PA_OutFlag, #bPAOF_DC
	bset	FlagsEdStat, #bFES_READ_ONLY
	btsc	TestFlags, #TF_DC_FREQ_ON
	bset	FlagsEdStat, #bFES_READ_ONLY
	return

octf_change:
	btst	PA_OutFlag, #bPAOF_DC
	bra	z, octf_no_dc
	btsc	TestFlags, #TF_DC_GEN_ON
;	GV_ON
	bset	GV_PORT, #GV_BIT
	rcall	SetUpFreq
octf_no_dc:

	return

; --------------------------
OnChangeTestFlagDcFq:
	cp	w3, #ON_CHANGE_VALUE
	bra	z, octf_change_dcfq
	cp	w3, #ON_CHANGE_OPEN
	bra	z, octf_dcfq_open
	return

octf_dcfq_open:
	btss	PA_OutFlag, #bPAOF_DC
	bset	FlagsEdStat, #bFES_READ_ONLY
	btsc	TestFlags, #TF_DC_GEN_ON
	bset	FlagsEdStat, #bFES_READ_ONLY
	return

octf_change_dcfq:
	btsc	TestFlags, #TF_DC_FREQ_ON
	rcall	SetOffsDcFqInit
	return

; --------------------------
OnChangeTestFlagFan:
	cp	w3, #ON_CHANGE_VALUE
	bra	z, octffan_change
	cp	w3, #ON_CHANGE_OPEN
	bra	z, octffan_open
	cp	w3, #ON_CHANGE_RELOAD
	bra	z, octffan_init
	return

octffan_open:
	btss	TestFlags, #bTF_FAN
	bset	FlagsEdStat, #bFES_READ_ONLY

octffan_init:
	clr	w0
	btsc	FAN1_PORT, #FAN1_BIT
	bset	w0, #0
	btsc	FAN2_PORT, #FAN2_BIT
	bset	w0, #0
	btsc	HT1_PORT, #HT1_BIT
	bset	w0, #2
	btsc	HT2_PORT, #HT2_BIT
	bset	w0, #3
	rcall	FlagsEdReloadValue
	return

octffan_change:
	btss	w0, #0
	bclr	FAN1_PORT, #FAN1_BIT
	btsc	w0, #0
	bset	FAN1_PORT, #FAN1_BIT

	btss	w0, #1
	bclr	FAN2_PORT, #FAN2_BIT
	btsc	w0, #1
	bset	FAN2_PORT, #FAN2_BIT

	btss	w0, #2
	bclr	HT1_PORT, #HT1_BIT
	btsc	w0, #2
	bset	HT1_PORT, #HT1_BIT

	btss	w0, #3
	bclr	HT2_PORT, #HT2_BIT
	btsc	w0, #3
	bset	HT2_PORT, #HT2_BIT
	return


; --------------------------
OnChangeTestFlagPow:
	cp	w3, #ON_CHANGE_VALUE
	bra	z, octfpow_change
	cp	w3, #ON_CHANGE_OPEN
	bra	z, octfpow_open
	cp	w3, #ON_CHANGE_RELOAD
	bra	z, octfpow_init
	return

octfpow_open:
	btss	TestFlags, #bTF_POW
	bset	FlagsEdStat, #bFES_READ_ONLY

octfpow_init:
	clr	w0
	btsc	PA_POW_PORT, #PA_POW_BIT
	bset	w0, #0
	btsc	OP_OFFS_PORT, #OP_OFFS_BIT
	bset	w0, #1
	btsc	OP1_ON_PORT, #OP1_ON_BIT
	bset	w0, #2
	btsc	GV_PORT, #GV_BIT
	bset	w0, #3
	rcall	FlagsEdReloadValue
	return

octfpow_change:
	btss	w0, #0
	bclr	PA_POW_PORT, #PA_POW_BIT
	btsc	w0, #0
	bset	PA_POW_PORT, #PA_POW_BIT

	btss	w0, #1
	bclr	OP_OFFS_PORT, #OP_OFFS_BIT
	btsc	w0, #1
	bset	OP_OFFS_PORT, #OP_OFFS_BIT

	btss	w0, #2
	bclr	OP1_ON_PORT, #OP1_ON_BIT
	btsc	w0, #2
	bset	OP1_ON_PORT, #OP1_ON_BIT

	btss	w0, #3
	bclr	GV_PORT, #GV_BIT
	btsc	w0, #3
	bset	GV_PORT, #GV_BIT

	return
